/*
 *심심해서 만든 총 특수능력 플러그인의 상수 정의 파일
 */
#if defined _TGMconsts_included
 #endinput
#endif
#define _TGMconsts_included

//이 값은 반드시 슈트로 이동 가능한 최대 속도보다 빨라야 한다.
//SUIT_SPEED_MAXSPEED 보다 이 값이 커야한다
#define TGM_SV_MAXSPEED 400.0

//택건서버는 자기 데미지를 허용할 것을 추천, 좀비모드는 비추천
//이유는 생각해보셈 오리지날에서도 수류탄에 팀뎀은 안먹어도자기는 뎀지먹음 ㅇㅇ 그래야 수류탄 조심해서 던짐


/********************************슈트 도움말 관련 설정******************************************/
#define TGMSUITHELPSOUNDDELAY 4.0 // 슈트 도움말의 지연 시간

/********************************총의 특수기술 관련 설정****************************************/

//셀렉터 타입
#define MAX_SELECTTYPE 10

//건드리지 마시오dont edit
enum gunselector{
	
	selector_none = 0,//아무것도 선택하지 않은 상태의 값, 기본적으로는 쓰이지 않아야 한다
	selector_bullet,//일반총알, 기본값
	selector_default = selector_bullet,
	selector_grenade,//유탄
	selector_rocket,//로켓
	selector_mine,//지뢰
	selector_sensor,//탐지장치
	selector_heal,//치료
	selector_energyball,//콤바인 코어볼
	selector_emp,//emp
	selector_specialgrenade,
	selector_last//기본적으로 쓰이지 않는 값
	
}

//총이 어떤 기술을 가지고 있는지 나타내는 플래그
#define ABILITY_NONE 0
#define ABILITY_KNIFE (1 << 0)//이 플래그는 무기가 칼임을 나타낸다.
#define ABILITY_BULLET (1 << 1)
#define ABILITY_GRENADE (1 << 2)
#define ABILITY_ROCKET (1 << 3)
#define ABILITY_MINE (1 << 4)
#define ABILITY_SENSOR (1 << 5)
#define ABILITY_HEAL (1 << 6)
#define ABILITY_ENERGYBALL (1 << 7)
#define ABILITY_EMP (1 << 8)
#define ABILITY_specialgrenade (1 << 9)
#define ABILITY_specialgrenadeDETONATE (1 << 10)
#define ABILITY_SMALLCLIP (1 << 11)
//이 플래그는 총이 산탄총이므로 탄환 처리에 특수해야함을 의미한다.
#define ABILITY_SHOTGUN ((1 << 12) | ABILITY_SMALLCLIP)
//이 플래그는 총이 볼트액션 저격총이므로 탄환 처리에 특수해야함을 의미한다.
#define ABILITY_BOLTACTIONGUN ((1 << 13) | ABILITY_SMALLCLIP)

#define GRENADE_WEAPONNAME "grenade launcher"
#define MINE_WEAPONNAME "sensormine"
#define ROCKET_WEAPONNAME "rocket"
#define ENERGYBALL_WEAPONNAME "combine energyball"
#define specialgrenade_WEAPONNAME "special grenade launcher"

#define EMP_WEAPONNAME "emp"


/*******************************************킬스트릭 특수기술 관련 설정**************************************/

//특수기술 타입
#define MAX_SPECIALSKILLTYPE 3

//건드리지 마시오
enum specialskilltype{
	
	skilltype_none = 0,
	skilltype_nuke = 1,
	skilltype_last
	
};

//각각의 특수기술이 필요로 하는 킬수의 양
new killsforspecialskill[MAX_SPECIALSKILLTYPE] = {
	
	0,//none
	8,//nuke
	0//last
	
};

//각각의줄에서 첫번째와 두번째 값은 안중요하고, 세번째는 테러, 네번째는 씨티의 기술 사용 가능 여부 설정
new const bool:teamcanusespecialskill[MAX_SPECIALSKILLTYPE][4] = {
	
	{false, false, false, false},//이것은 각 팀이 f1의 특수 기술을 근본적으로 사용할수 있는가 없는가를 결정한다
	{false, false, true, true},//nuke
	{false, false, false, false}//last
	
};

//특수기술 핵 관련 처리, 소숫점 단위로 기록된것은 반드시 소숫점 단위까지 적어야 한다
new const String:NUKEMODEL[] = "models/props_combine/headcrabcannister01a.mdl"; //핵의 모델
#define NUKE_SPEED 400.0//핵의 낙하속도
#define NUKE_DAMAGE_TO_BREAK 200//얼마의 데미지를 입어야 공중에서 핵폭발하는가
#define NUKEDAMAGE 50000 //숙주좀이고 나발이고 다 싱하형이랑 같이 가는거다
#define NUKESTARTDISTANCEFROMSKY 100.0 //미사일이 떨어지기 시작할 때 미사일이 하늘과 어느 거리를 두고 스폰되나?
#define MINDISTTOSHOWNUKE 200.0 //지면에서 하늘까지 어느 정도의 여유가 있어야 미사일이 보일 것인가(사람 키가 64)
#define TIMETOSTARTNUKEWARNINGSOUND 4.0 //핵 발사 결정 후의 경고음이 몇초 뒤부터 시작될 것인가
#define TIMETOSHOWNUKE 15.0 //핵 발사 결정 후 몇초에 미사일이 투하되기 시작할 것인가?(미사일을 보일 수 없는 경우 이 시점에 폭발)
#define DISTTONUKEKILL 500.0 //핵 폭발로부터 이 거리 안에 있는 인간은 무조건 사망

#define NUKE_WEAPONNAME "nuke"

//핵으로부터는 킬스트릭을 얻지 않는다
#define NOKILLSFROMNUKE true

/*********************************************슈트기능 관련 설정**************************************/

//슈트기능 타입
#define MAX_SUITSKILLTYPE 8

enum suitmodeselector{
	
	suitmode_none = 0,
	suitmode_charge,
	suitmode_default = suitmode_charge,
	suitmode_speed,
	suitmode_strength,
	suitmode_cloak,
	suitmode_shield,
	suitmode_sensor,
	suitmode_last
	
}

//이 아래로는 소스엔진에서 가져온 상수 정의, 마우스 커서 혹은 키보드 커서를 대지 마시오(손은 못대지)
//defines from sourceengine

enum{
	
	EF_BONEMERGE			= 0x001,	// Performs bone merge on client side
	EF_BRIGHTLIGHT 			= 0x002,	// DLIGHT centered at entity origin
	EF_DIMLIGHT 			= 0x004,	// player flashlight
	EF_NOINTERP				= 0x008,	// don't interpolate the next frame
	EF_NOSHADOW				= 0x010,	// Don't cast no shadow
	EF_NODRAW				= 0x020,	// don't draw entity
	EF_NORECEIVESHADOW		= 0x040,	// Don't receive no shadow
	EF_BONEMERGE_FASTCULL	= 0x080,	// For use with EF_BONEMERGE. If this is set, then it places this ent's origin at its
										// parent and uses the parent's bbox + the max extents of the aiment.
										// Otherwise, it sets up the parent's bones every frame to figure out where to place
										// the aiment, which is inefficient because it'll setup the parent's bones even if
										// the parent is not in the PVS.
	EF_ITEM_BLINK			= 0x100,	// blink an item so that the user notices it.
	EF_PARENT_ANIMATES		= 0x200,	// always assume that the parent entity is animating
	EF_MAX_BITS = 10
	
};

//for m_MoveCollide
enum MoveCollide_t
{
	MOVECOLLIDE_DEFAULT = 0,

	// These ones only work for MOVETYPE_FLY + MOVETYPE_FLYGRAVITY
	MOVECOLLIDE_FLY_BOUNCE,	// bounces, reflects, based on elasticity of surface and object - applies friction (adjust velocity)
	MOVECOLLIDE_FLY_CUSTOM,	// Touch() will modify the velocity however it likes
	MOVECOLLIDE_FLY_SLIDE,  // slides along surfaces (no bounce) - applies friciton (adjusts velocity)

	MOVECOLLIDE_COUNT,		// Number of different movecollides

	// When adding new movecollide types, make sure this is correct
	MOVECOLLIDE_MAX_BITS = 3
};

// edict->solid values
// NOTE: Some movetypes will cause collisions independent of SOLID_NOT/SOLID_TRIGGER when the entity moves
// SOLID only effects OTHER entities colliding with this one when they move - UGH!

// Solid type basically describes how the bounding volume of the object is represented
// NOTE: SOLID_BBOX MUST BE 2, and SOLID_VPHYSICS MUST BE 6
// NOTE: These numerical values are used in the FGD by the prop code (see prop_dynamic)

//for m_CollisionGroup
enum Collision_Group_t
{
	COLLISION_GROUP_NONE  = 0,
	COLLISION_GROUP_DEBRIS,			// Collides with nothing but world and static stuff
	COLLISION_GROUP_DEBRIS_TRIGGER, // Same as debris, but hits triggers
	COLLISION_GROUP_INTERACTIVE_DEBRIS,	// Collides with everything except other interactive debris or debris
	COLLISION_GROUP_INTERACTIVE,	// Collides with everything except interactive debris or debris
	COLLISION_GROUP_PLAYER,
	COLLISION_GROUP_BREAKABLE_GLASS,
	COLLISION_GROUP_VEHICLE,
	COLLISION_GROUP_PLAYER_MOVEMENT,  // For HL2, same as Collision_Group_Player
										
	COLLISION_GROUP_NPC,			// Generic NPC group
	COLLISION_GROUP_IN_VEHICLE,		// for any entity inside a vehicle
	COLLISION_GROUP_WEAPON,			// for any weapons that need collision detection
	COLLISION_GROUP_VEHICLE_CLIP,	// vehicle clip brush to restrict vehicle movement
	COLLISION_GROUP_PROJECTILE,		// Projectiles!
	COLLISION_GROUP_DOOR_BLOCKER,	// Blocks entities not permitted to get near moving doors
	COLLISION_GROUP_PASSABLE_DOOR,	// Doors that the player shouldn't collide with
	COLLISION_GROUP_DISSOLVING,		// Things that are dissolving are in this group
	COLLISION_GROUP_PUSHAWAY,		// Nonsolid on client and server, pushaway in player code

	COLLISION_GROUP_NPC_ACTOR,		// Used so NPCs in scripts ignore the player.

	LAST_SHARED_COLLISION_GROUP
};

//for m_nSolidType
enum SolidType_t
{
	SOLID_NONE			= 0,	// no solid model
	SOLID_BSP			= 1,	// a BSP tree
	SOLID_BBOX			= 2,	// an AABB
	SOLID_OBB			= 3,	// an OBB (not implemented yet)
	SOLID_OBB_YAW		= 4,	// an OBB, constrained so that it can only yaw
	SOLID_CUSTOM		= 5,	// Always call into the entity for tests
	SOLID_VPHYSICS		= 6,	// solid vphysics object, get vcollide from the model and collide with that
	SOLID_LAST,
};


//for m_usSolidFlags
enum SolidFlags_t
{
	FSOLID_CUSTOMRAYTEST		= 0x0001,	// Ignore solid type + always call into the entity for ray tests
	FSOLID_CUSTOMBOXTEST		= 0x0002,	// Ignore solid type + always call into the entity for swept box tests
	FSOLID_NOT_SOLID			= 0x0004,	// Are we currently not solid?
	FSOLID_TRIGGER				= 0x0008,	// This is something may be collideable but fires touch functions
											// even when it's not collideable (when the FSOLID_NOT_SOLID flag is set)
	FSOLID_NOT_STANDABLE		= 0x0010,	// You can't stand on this
	FSOLID_VOLUME_CONTENTS		= 0x0020,	// Contains volumetric contents (like water)
	FSOLID_FORCE_WORLD_ALIGNED	= 0x0040,	// Forces the collision rep to be world-aligned even if it's SOLID_BSP or SOLID_VPHYSICS
	FSOLID_USE_TRIGGER_BOUNDS	= 0x0080,	// Uses a special trigger bounds separate from the normal OBB
	FSOLID_ROOT_PARENT_ALIGNED	= 0x0100,	// Collisions are defined in root parent's local coordinate space

	FSOLID_MAX_BITS	= 9
};