/*
 *tacticalgunmod
 */

new const String:TacticalGunModVersion[60] = "2.2.5.55";

public Plugin:myinfo = {
	
	name = "TacticalGunMod",
	author = "javalia",
	description = "powerful gun and suit",
	version = TacticalGunModVersion,
	url = "http://www.sourcemod.net/"
	
};

//인클루드문장
#include <sourcemod>
#include <sdktools>
#include <cstrike>
#include "sdkhooks"
#include "dhooks"
#include "stocklib"

//이 인클루드 파일들은 다른 파일들(의 일부 변수에)에 접근할 필요가 없다
#include "TGM2/TGM2consts"
#include "TGM2/TGM2sound"

//문법정의
#pragma semicolon 1

new Handle:funcgetplayermaxspeed = INVALID_HANDLE;

//오프셋 관련
new Weapon_Offset = -1;

new suitmodeselector:suitmode[MAXPLAYERS + 1];
new gunselector:gunselectormode[MAXPLAYERS + 1];
new specialskilltype:specialskillmode[MAXPLAYERS + 1];
new keybuffer[MAXPLAYERS + 1];
new abilitybuffer[MAXPLAYERS + 1];

//특수기능들을 위한 변수
new Float:nextsuitactivetime[MAXPLAYERS + 1];//슈트의 에너지가 다음에 조정될 시간
new Float:nextcloakactivetime[MAXPLAYERS + 1];
new cloakalpha[MAXPLAYERS + 1]; //클로킹의 투명도를 저장하는 변수
new Float:nextsuitsensortime[MAXPLAYERS + 1];//슈트의 탐지기능이 발동될 시간

//레이저도트 관련
new laserdotentity[MAXPLAYERS + 1];//여기에는 엔티티 인덱스가 아니라 엔티티 레퍼런스를 저장한다!

//마인 관련
new mineentity[2048];//해당 env_beam엔티티와 연관된 마인엔티티, 여기에는 엔티티 인덱스가 아니라 엔티티 레퍼런스를 저장한다.
new minegroundentity[2048];//여기에는 마인엔티티가 어떤 엔티티에 붙어있는지 저장한다

//콤바인 코어볼 관련
new bool:chargingenergyball[MAXPLAYERS + 1];//에너지볼 발사 대기시간인가?
new energyballtouchcount[2048];//에너지볼이 닿은 횟수

//이펙트엔티티
new beamsprite, halosprite, plasmabeam, plasmahalo;

//소리 관련 엔티티
new bool:playingrocketsound[2048];
new bool:playingenergyballsound[2048];
new bool:playingsensorsound[2048];

//센서를 위한 변수
new Float:nextsensoractivetime[MAXPLAYERS + 1];
new bool:detectedbysensor[MAXPLAYERS + 1][MAXPLAYERS + 1];
new bool:detectedonminimap[MAXPLAYERS + 1];

new gunfunctionlimit[MAXPLAYERS + 1][MAX_SELECTTYPE];

//킬스트릭을 위한 변수
new kills[MAXPLAYERS + 1];

//이 인클루드 파일들은 모든 전역변수에 접근 가능해야 한다
#include "TGM2/TGM2cvars"

public OnPluginStart(){
	
	createtacticalgunmodcvar();
	
	//트렌슬레이션 파일 로드
	LoadTranslations("tacticalgunmod.phrases");
	
	//이벤트 훅
	HookEvent("player_spawn", EventSpawn);
	HookEvent("player_hurt", EventHurt);
	HookEvent("player_death", EventDeath);
	HookEvent("weapon_fire", EventWeaponFire);
	
	HookEvent("weapon_fire_on_empty", EventEmptyShot);
	
	//커맨드 훅
	if(AddCommandListener(cmdlistenernightvision, "nightvision")){
		
		PrintToServer("[SM] TacticalGunMod : %T", "nightvisioncmdhooksuccess", LANG_SERVER);
		
	}else{
		
		PrintToServer("[SM] TacticalGunMod : %T", "nightvisioncmdhookfail", LANG_SERVER);
		
	}
	
	//커맨드 훅
	if(AddCommandListener(cmdlistenerautobuy, "autobuy")){
		
		PrintToServer("[SM] TacticalGunMod : %T", "autobuycmdhooksuccess", LANG_SERVER);
		
	}else{
		
		PrintToServer("[SM] TacticalGunMod : %T", "autobuycmdhookfail", LANG_SERVER);
		
	}
	
	//커맨드 훅
	if(AddCommandListener(cmdlistenerrebuy, "rebuy")){
		
		PrintToServer("[SM] TacticalGunMod : %T", "rebuycmdhooksuccess", LANG_SERVER);
		
	}else{
		
		PrintToServer("[SM] TacticalGunMod : %T", "rebuycmdhookfail", LANG_SERVER);
		
	}
	
	//콘바 훅
	new Handle:cvar_svmaxspeed = INVALID_HANDLE;
	
	cvar_svmaxspeed = FindConVar("sv_maxspeed");
	
	if(cvar_svmaxspeed != INVALID_HANDLE){
		
		HookConVarChange(cvar_svmaxspeed, cvarhook_svmaxspeed);
		
	}
	
	SetConVarFloat(cvar_svmaxspeed, TGM_SV_MAXSPEED);
	
	//무기 리스트 훅
	Weapon_Offset = FindSendPropOffs("CCSPlayer", "m_hMyWeapons");
	
	new Handle:gameconfig = LoadGameConfigFile("tacticalgunmod.games");
	if(gameconfig == INVALID_HANDLE){
	
		SetFailState("[SM] TacticalGunMod : %T", "getplayermaxspeedfunctionhookfail", LANG_SERVER);
	
	}
	
	funcgetplayermaxspeed = DHookCreate(GameConfGetOffset(gameconfig, "GetMaxPlayerSpeed"), HookType_Entity, ReturnType_Float, ThisPointer_CBaseEntity, GetMaxPlayerSpeedPostHook);
	
	if(funcgetplayermaxspeed != INVALID_HANDLE){
	
		PrintToServer("[SM] TacticalGunMod : %T", "getplayermaxspeedfunctionhooksuccess", LANG_SERVER);
	
	}else{
	
		SetFailState("[SM] TacticalGunMod : %T", "getplayermaxspeedfunctionhookfail", LANG_SERVER);
	
	}
	
	if(gameconfig != INVALID_HANDLE){
	
		CloseHandle(gameconfig);
	
	}
	
}

public cvarhook_svmaxspeed(Handle:convar, const String:oldValue[], const String:newValue[]){
	
	if(StringToFloat(newValue) != TGM_SV_MAXSPEED){
		
		SetConVarFloat(convar, TGM_SV_MAXSPEED);
		
	}
	
}

//n키의 훅
public Action:cmdlistenernightvision(client, const String:command[], arg){
	
	if(client == 0) return Plugin_Continue;
	
	if(isClientConnectedIngameAlive(client)){
	
		if((specialskillmode[client] == skilltype_nuke) && (kills[client] >= killsforspecialskill[skilltype_nuke])){
			
			if(teamcanusespecialskill[skilltype_nuke][GetClientTeam(client)]){
				
				kills[client] = kills[client] - killsforspecialskill[skilltype_nuke];
				usenukeskill(client);
				
			}
			
		}
		
	}
	
	if(specialskillmode[client] == skilltype_none){
		
		return Plugin_Continue;
		
	}else{
		
		return Plugin_Handled;
		
	}
	
}

//f1키의 훅
public Action:cmdlistenerautobuy(client, const String:command[], arg){
	
	if(client == 0) return Plugin_Continue;
	
	if(isClientConnectedIngameAlive(client)){
		
		if(teamcanusespecialskill[skilltype_none][GetClientTeam(client)]){
		
			specialskillmenu(client);
			
		}
	
	}
	
	return Plugin_Continue;
	
}

//f2키의 훅
public Action:cmdlistenerrebuy(client, const String:command[], arg){
	
	if(client == 0) return Plugin_Continue;
	
	if(isClientConnectedIngameAlive(client)){
		
		suitmodemenu(client);
		
	}
	
	return Plugin_Continue;
	
}

public OnMapStart(){
	
	beamsprite = PrecacheModel("materials/sprites/laserbeam.vmt", true);
	halosprite = PrecacheModel("materials/sprites/halo01.vmt", true);
	plasmabeam = PrecacheModel("materials/sprites/plasma.vmt", true);
	plasmahalo = PrecacheModel("materials/sprites/plasmahalo.vmt", true);
	PrecacheModel("models/Items/ar2_grenade.mdl", true);
	PrecacheModel("models/items/combine_rifle_ammo01.mdl", true);
	PrecacheModel("models/weapons/w_missile_launch.mdl", true);
	PrecacheModel("models/effects/combineball.mdl", true);
	PrecacheModel("models/weapons/w_grenade.mdl", true);
	PrecacheModel(NUKEMODEL, true);
	prepatchsounds();
	
	for(new i = 0; i < 2048; i++){
		
		playingrocketsound[i] = false;
		playingenergyballsound[i] = false;
		playingsensorsound[i] = false;
		
	}
	
	for(new target = 1; target <= MaxClients; target++){
		
		detectedonminimap[target] = false;
		
	}
	
	AutoExecConfig();
	
	new playermanagerentity = FindEntityByClassname(0, "cs_player_manager");
	SDKHook(playermanagerentity, SDKHook_ThinkPost, pmentityThinkPostHook);
	
}


public pmentityThinkPostHook(entity){
	
	new minimapoffset = FindSendPropOffs("CCSPlayerResource", "m_bPlayerSpotted");
	
	for(new target = 1; target <= MaxClients; target++){
		
		if(detectedonminimap[target]){
				
			SetEntData(entity, minimapoffset + target, true);
			detectedonminimap[target] = false;
		
		}else if(cloakalpha[target] <= GetConVarInt(cvar_suit_cloak_hide_from_minimap)){
		
			SetEntData(entity, minimapoffset + target, false);
		
		}
		
	}
	
	//always spot the c4 for cts.
	//SetEntData(entity, FindSendPropOffs("CCSPlayerResource", "m_bBombSpotted"), true, 4, true);
		
}  

public OnClientPutInServer(client){
	
	suitmode[client] = suitmode_default;
	gunselectormode[client] = selector_default;
	specialskillmode[client] = skilltype_none;
	keybuffer[client] = 0;
	abilitybuffer[client] = 0;
	laserdotentity[client] = -1;
	
	chargingenergyball[client] = false;
	
	nextsuitactivetime[client] = GetGameTime();
	nextcloakactivetime[client] = GetGameTime();
	nextsuitsensortime[client] = GetGameTime();
	cloakalpha[client] = 255;
	
	kills[client] = 0;
	
	nextsuithelpsound[client] = GetGameTime();
	suithelpsoundreserve[client] = INVALID_HANDLE;
	
	for(new i = 0; i < MAX_SELECTTYPE;i++){
		
		gunfunctionlimit[client][i] = 0;
		
	}
	
	for(new i = 1; i <= MaxClients; i++){
		
		detectedbysensor[client][i] = false;
		
	}
	
	SDKHook(client, SDKHook_WeaponSwitch, WeaponSwitchHook);
	SDKHook(client, SDKHook_WeaponDrop, WeaponDropHook);
	SDKHook(client, SDKHook_PreThink, PreThinkHook);
	SDKHook(client, SDKHook_PostThink, PostThinkHook);
	SDKHook(client, SDKHook_OnTakeDamage, OnTakeDamageHook);
	
	DHookEntity(funcgetplayermaxspeed, true, client);
	
}

public OnClientDisconnect(client){
	
	removelaserdot(client);
	
	cancelreservesuithelpsound(client);
	
	if(GetConVarFloat(cvar_specialgrenade_life_time) <= 0.0){
		
		//detonate without damage
		detonateSpecialGrenade(client, true);
	
	}
	
}

//특수 공격 함수에서 다음 공격시간을 지연시킨 이후에,
//바로 다음 공격을 처리하려고 하면,
//그 때에 클라이언트 사이드에서 만약 공격 단추가 눌려있을 경우, 클라이언트는 총이 발사될 것으로 예측하고,
//그 예측에 따라서 총 발사 애니메이션과 총알의 이펙트 처리를 한다.
//그런 버그가 있지만 어쩔수 없다
//샷건은 재장전의 특성상 짜증나는 버그가 특히 많았다.
//특수기술 셀렉터가 설정된 상태로 e키를 계속 누르면서 재정전을 계속할 경우,
//총알이 장전되지 않는 치명적인 버그가 생기기도 했다.

public PreThinkHook(client){
	
	if(isClientConnectedIngameAlive(client)){
			
		new buttons = GetClientButtons(client);
		
		//시프트 관련 처리, 현재 시프트를 누르고 있고 키버퍼에서는 시프트를 계속 누르는 중이 아니라고 할때만
		if((buttons & IN_SPEED) && !(keybuffer[client] & IN_SPEED)){
			
			//시프트를 누를 때 키버퍼 체크
			keybuffer[client] = keybuffer[client] | IN_SPEED;
			
			abilitybuffer[client] = getweaponability(client, GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon"));
			
			if(abilitybuffer[client] >= ABILITY_BULLET){
	
				selectormenu(client);
				
			}else{
				
				PrintToChat(client, "\x04%T", "gunselectornoselector", client);
				
			}
			
		}else if(!(buttons & IN_SPEED)){
			
			//시프트를 누르고 있지 않으므로 버퍼를 푼다
			keybuffer[client] = keybuffer[client] & ~IN_SPEED;
			
		}
		
		//탭키의 처리
		
		//E키로 특수 기술을 쓰는 보조 공격모드에서의 처리
		if(buttons & IN_USE && !(keybuffer[client] & IN_USE)){
			
			//만약 모드가 탄환 모드가 아닐 경우에는, 특수기술을 쓴다
			if(gunselectormode[client] != selector_bullet){
				
				//특수 기술 함수 호출
				specialattack(client);
				
			}
			
		}else if(!(buttons & IN_USE)){
			
			//E키를 누르고 있지 않으므로 버퍼를 푼다
			keybuffer[client] = keybuffer[client] & ~IN_USE;
			
		}
		
		new Float:nowtime = GetGameTime();
		
		new bool:iscloaking = false;
		
		new armorvalue = GetEntProp(client, Prop_Data, "m_ArmorValue");
		
		//슈트 모드의 기능들에 대한 처리
		if(suitmode[client] == suitmode_charge){
			
			if(nextsuitactivetime[client] < nowtime){
				
				nextsuitactivetime[client] = nowtime + GetConVarFloat(cvar_suit_charge_delay);
				
				if(armorvalue + GetConVarInt(cvar_suit_charge_energy) < GetConVarInt(cvar_suit_max_charge)){
					
					SetEntProp(client, Prop_Data, "m_ArmorValue", armorvalue + GetConVarInt(cvar_suit_charge_energy)); 
					
				}else{
					
					SetEntProp(client, Prop_Data, "m_ArmorValue", GetConVarInt(cvar_suit_max_charge)); 
					
				}
				
			}
			
		}else if(suitmode[client] == suitmode_strength){
			
			if((buttons & IN_JUMP) && (GetEntityFlags(client) & FL_ONGROUND)){
			
				//충분한 방탄복이 있을 경우 점프를 무효화하고 높은 점프를 하게 해준다
				if(armorvalue >= GetConVarInt(cvar_suit_strength_jump_energy)){
					
					SetEntProp(client, Prop_Data, "m_ArmorValue", armorvalue - GetConVarInt(cvar_suit_strength_jump_energy)); 
					
					SetClientButtons(client, buttons & ~IN_JUMP);
					
					decl Float:playerspeed[3];
					GetEntPropVector(client, Prop_Data, "m_vecVelocity", playerspeed);
					playerspeed[2] = playerspeed[2] + GetConVarFloat(cvar_suit_strength_jump_speed);
					TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, playerspeed);
					
					//점프를 하고 난 뒤에도 충분한 양의 아머가 있을 경우가 아니면 충전모드로 전환
					if(armorvalue - GetConVarInt(cvar_suit_strength_jump_energy) <= 0 || armorvalue - GetConVarInt(cvar_suit_strength_jump_energy) < (GetConVarInt(cvar_suit_strength_jump_energy) < GetConVarInt(cvar_suit_strength_knife_energy) ? GetConVarInt(cvar_suit_strength_jump_energy) : GetConVarInt(cvar_suit_strength_knife_energy))){
						
						PrintToChat(client, "\x04%T", "suitenergydepleted", client);
						
						setclientsuitfucntion(client, suitmode_charge);
						
						cancelreservesuithelpsound(client);
						playsuithelpsound(client, SOUNDSUITNOENERGY);
						
					}
					
				}else if(armorvalue < (GetConVarInt(cvar_suit_strength_jump_energy) < GetConVarInt(cvar_suit_strength_knife_energy) ? GetConVarInt(cvar_suit_strength_jump_energy) : GetConVarInt(cvar_suit_strength_knife_energy))){
					
					PrintToChat(client, "\x04%T", "suitenergydepleted", client);
					
					setclientsuitfucntion(client, suitmode_charge);
					
					cancelreservesuithelpsound(client);
					playsuithelpsound(client, SOUNDSUITNOENERGY);
					
				}
				
			}
			
		}else if(suitmode[client] == suitmode_cloak){
			
			if(armorvalue >= GetConVarInt(cvar_suit_cloak_energy)){
				
				iscloaking = true;
				
				if(nextsuitactivetime[client] < nowtime){
					
					nextsuitactivetime[client] = nowtime + GetConVarFloat(cvar_suit_cloak_energy_delay);
					
					SetEntProp(client, Prop_Data, "m_ArmorValue", armorvalue - GetConVarInt(cvar_suit_cloak_energy));
				}
				
				if(nextcloakactivetime[client] < nowtime){
					
					nextcloakactivetime[client] = nowtime + GetConVarFloat(cvar_suit_cloak_change_delay);
					
					if(cloakalpha[client] - GetConVarInt(cvar_suit_cloak_cloaking_speed) >= GetConVarInt(cvar_suit_cloak_min_alpha)){
							
						cloakalpha[client] = cloakalpha[client] - GetConVarInt(cvar_suit_cloak_cloaking_speed);
						
					}else{
						
						cloakalpha[client] = GetConVarInt(cvar_suit_cloak_min_alpha);
						
					}
					
					SetEntityRenderMode(client, RENDER_GLOW);
					SetEntityRenderColor(client, 255, 255, 255, cloakalpha[client]);
					
					adjustweapontransparency(client, RENDER_GLOW);
					
				}
				
			}else{
					
				PrintToChat(client, "\x04%T", "suitenergydepleted", client);
				
				setclientsuitfucntion(client, suitmode_charge);
				
				cancelreservesuithelpsound(client);
				playsuithelpsound(client, SOUNDSUITNOENERGY);
				
			}
			
		}else if(suitmode[client] == suitmode_shield){
			
			
			
		}else if(suitmode[client] == suitmode_sensor){
			
			if(armorvalue >= GetConVarInt(cvar_suit_sensor_energy)){
				
				if(nextsuitsensortime[client] < nowtime){
				
					nextsuitsensortime[client] = nowtime + GetConVarFloat(cvar_suit_sensor_delay);
					
					decl Float:clientposition[3];
					GetClientEyePosition(client, clientposition);
					
					for(new target = 1; target <= MaxClients; target++){
							
						//타겟이 클라이언트가 아니고 타겟이 살아있을 경우
						if(target != client && isClientConnectedIngameAlive(target)){
							
							//트레이스를 써서 감지한다
							decl Float:targetposition[3], Float:vectordirection[3], Float:angledirection[3];
							GetClientEyePosition(target, targetposition);
							targetposition[2] = targetposition[2] - 15.0;//몸통의 가운데 부분을 구한다
							
							MakeVectorFromPoints(clientposition, targetposition, vectordirection);
							GetVectorAngles(vectordirection, angledirection);
									
							new Handle:traceresulthandle = INVALID_HANDLE;
					
							traceresulthandle = TR_TraceRayFilterEx(clientposition, angledirection, MASK_SOLID, RayType_Infinite, tracerayfilterdefault, client);
					
							if(TR_DidHit(traceresulthandle)){
						
								if(TR_GetEntityIndex(traceresulthandle) == target){
									
									detectedbysensor[client][target] = true;
									detectedonminimap[target] = true;
											
								}
										
							}
									
							CloseHandle(traceresulthandle);
						
						}
						
					}
					
				}
				
				if(nextsuitactivetime[client] < nowtime){
					
					nextsuitactivetime[client] = nowtime + GetConVarFloat(cvar_suit_sensor_energy_delay);
					
					SetEntProp(client, Prop_Data, "m_ArmorValue", armorvalue - GetConVarInt(cvar_suit_sensor_energy));
					
				}
				
			}else{
				
				PrintToChat(client, "\x04%T", "suitenergydepleted", client);
				
				setclientsuitfucntion(client, suitmode_charge);
				
				cancelreservesuithelpsound(client);
				playsuithelpsound(client, SOUNDSUITNOENERGY);
				
			}
			
		}else if(suitmode[client] == suitmode_speed){
			
			if(((buttons & IN_FORWARD) || (buttons & IN_BACK) || (buttons & IN_MOVELEFT) || (buttons & IN_MOVERIGHT)) && !(buttons & IN_DUCK) && !(buttons & IN_SPEED) && (GetEntityFlags(client) & FL_ONGROUND)){
				
				if(armorvalue >= GetConVarInt(cvar_suit_speed_energy)){
					
					if(nextsuitactivetime[client] < nowtime){
					
						nextsuitactivetime[client] = nowtime + GetConVarFloat(cvar_suit_speed_delay);
						SetEntProp(client, Prop_Data, "m_ArmorValue", armorvalue - GetConVarInt(cvar_suit_speed_energy)); 
						
					}
					
				}else{
					
					PrintToChat(client, "\x04%T", "suitenergydepleted", client);
					
					setclientsuitfucntion(client, suitmode_charge);
					
					cancelreservesuithelpsound(client);
					playsuithelpsound(client, SOUNDSUITNOENERGY);
					
				}
				
			}
			
		}
		
		if(!iscloaking){
			
			if(nextcloakactivetime[client] < nowtime){
					
				nextcloakactivetime[client] = nowtime + GetConVarFloat(cvar_suit_cloak_change_delay);
				
				if(cloakalpha[client] + GetConVarInt(cvar_suit_cloak_decloaking_speed) <= 255){
						
					cloakalpha[client] = cloakalpha[client] + GetConVarInt(cvar_suit_cloak_decloaking_speed);
					SetEntityRenderMode(client, RENDER_GLOW);
					SetEntityRenderColor(client, 255, 255, 255, cloakalpha[client]);
					
					adjustweapontransparency(client, RENDER_GLOW);
					
				}else{
					
					cloakalpha[client] = 255;
					SetEntityRenderMode(client, RENDER_NORMAL);
					SetEntityRenderColor(client, 255, 255, 255, cloakalpha[client]);
					
					adjustweapontransparency(client, RENDER_NORMAL);
					
				}
				
			}
			
		}
		
		//에너지볼 발사를 위해 대기중이다
		if(chargingenergyball[client]){
			
			if((gunselectormode[client] == selector_energyball) && (abilitybuffer[client] & ABILITY_ENERGYBALL)){
			
				//에너지볼 발사
				fireenergyball(client);
				
			}else{
				
				//무기가 에너지볼 발사를 지원하지 않으므로 발사 대기를 해제한다
				chargingenergyball[client] = false;
				
			}
			
		}
		
	}
	
}

public PostThinkHook(client){
	
	if(isClientConnectedIngame(client)){
		
		if(IsPlayerAlive(client) && (abilitybuffer[client] & ABILITY_ROCKET) && (gunselectormode[client] == selector_rocket)){
		
			//레이저를 켜야하는 상황
			createlaserdot(client);
		
		}else{
			
			//레이저를 꺼야하는 상황
			removelaserdot(client);
			
		}
		
		if(!IsFakeClient(client)){
			
			new Float:now = GetEngineTime();
			
			if(nextsensoractivetime[client] <= now){
				
				nextsensoractivetime[client] = now + GetConVarFloat(cvar_sensor_show_delay);
				
				decl Float:clientposition[3];
				GetClientEyePosition(client, clientposition);
				clientposition[2] = clientposition[2] - 15.0;//몸통의 가운데 부분을 구한다
				
				new total = 0;
				new clients[MaxClients];
				
				new bool:alive[MaxClients + 1];
				new team[MaxClients + 1];
				
				team[client] = GetClientTeam(client);
				
				for(new target = 1; target <= MaxClients; target++){
					
					//살아있는 경우
					if(isClientConnectedIngameAlive(target)){
					
						alive[target] = true;
						team[target] = GetClientTeam(target);
						
						//이 코드는 센서의 감지레이저를 보낼 사람의 목록을 만든다
						if(team[client] == team[target]){
							
							clients[total++] = target;
							
						}
						
					}
					
				}
				
				for(new target = 1; target <= MaxClients; target++){
					
					//살아있는 경우
					if(alive[target]){
						
						//타겟이 클라이언트가 아니고 타겟이 살아있을 경우
						if(detectedbysensor[client][target] && (target != client)){
							
							decl Float:targetposition[3];
							GetClientEyePosition(target, targetposition);
							targetposition[2] = targetposition[2] - 15.0;//몸통의 가운데 부분을 구한다
							
							//타겟이 감지되었다!!!!이펙트를 만들어줘야 한다!!!
							if(team[target] == CS_TEAM_T){
								
								//테러 이므로 레이더는 빨간색
								new color[4] = {255, 64, 64, 255};
								TE_SetupBeamPoints(clientposition, targetposition, beamsprite, halosprite, 0, 1, 0.1, 1.0, 1.0, 0, 1.5, color, 40);
								
							}else if(team[target] == CS_TEAM_CT){
								
								//대테러 이므로 레이더는 파란색
								new color[4] = {0, 0, 255, 255};
								TE_SetupBeamPoints(clientposition, targetposition, beamsprite, halosprite, 0, 1, 0.1, 1.0, 1.0, 0, 1.5, color, 40);
								
							}
							
							TE_Send(clients, total, 0.0);
							
							detectedbysensor[client][target] = false;
							
						}
						
					}
					
				}
				
				//특수복 표시 기능을 덧붙여둔다
				
				if(IsPlayerAlive(client) && isteamsuitdisplayenabled(GetClientTeam(client))){
				
					decl String:msg[255];
					Format(msg, 255, "%T : %d", "suitenergydisplay", client, GetEntProp(client, Prop_Data, "m_ArmorValue"));
					
					sendKeyHintTextMsg(client, "%s", msg);
					
				}
					
			}
			
		}
			
	}
	
}


public Action:OnTakeDamageHook(client, &attacker, &inflictor, &Float:damage, &damagetype){
	
	if(isClientConnectedIngame(client) && isClientConnectedIngame(attacker)){
		
		//팀킬방지 혹은 자기 피해 방지
		if((client != attacker && GetClientTeam(client) == GetClientTeam(attacker) && !GetConVarBool(cvar_allow_teamdamage)) || ((client == attacker) && !GetConVarBool(cvar_allow_selfdamage))){
			
			return Plugin_Handled;
			
		}
		
		
	}
	
	//무기가 emp라면 더이상의 처리를 하지 않고 피격자의 아머를 0으로 한 이후 아머 무력화를 한 이후에 끝마친다
	if(attacker != inflictor){
	
		new String:weaponname[32];
		
		GetEdictClassname(inflictor, weaponname, 32);
		
		if(StrEqual(weaponname, EMP_WEAPONNAME, false)){
			
			SetEntProp(client, Prop_Data, "m_ArmorValue", 0);
			//피격자의 아머를 0으로 만들고 끝
			PrintToChat(client, "\x04%T", "suitenergydepleted", client);
			setclientsuitfucntion(client, suitmode_charge);
			
			cancelreservesuithelpsound(client);
			playsuithelpsound(client, SOUNDSUITNOENERGY);
			
			return Plugin_Handled;
			
		}
		
	}
	
	new bool:damagechanged = false;
	
	new clientarmorvalue = GetEntProp(client, Prop_Data, "m_ArmorValue");
	
	if(isClientConnectedIngame(attacker)){
		
		CloakingDisable(attacker);
		
		new attackerarmorvalue = GetEntProp(attacker, Prop_Data, "m_ArmorValue");
		
		//공격자가 최대 힘 모드이고 무기가 칼인 경우, 데미지를 추가하고, 마나를 깎는다
		if(suitmode[attacker] == suitmode_strength && (abilitybuffer[attacker] & ABILITY_KNIFE) && attacker == inflictor){
				
			if(attackerarmorvalue >= GetConVarInt(cvar_suit_strength_knife_energy)){
				
				SetEntProp(attacker, Prop_Data, "m_ArmorValue", attackerarmorvalue - GetConVarInt(cvar_suit_strength_knife_energy)); 
				damage = damage + GetConVarInt(cvar_suit_strength_knife_power);
				damagechanged = true;
				
				if(attackerarmorvalue - GetConVarInt(cvar_suit_strength_knife_energy) <= 0 || attackerarmorvalue - GetConVarInt(cvar_suit_strength_jump_energy) < (GetConVarInt(cvar_suit_strength_jump_energy) < GetConVarInt(cvar_suit_strength_knife_energy) ? GetConVarInt(cvar_suit_strength_jump_energy) : GetConVarInt(cvar_suit_strength_knife_energy))){
					
					//공격 이후 에너지가 부족한경우
					PrintToChat(attacker, "\x04%T", "suitenergydepleted", client);
					setclientsuitfucntion(client, suitmode_charge);
					
					cancelreservesuithelpsound(attacker);
					playsuithelpsound(attacker, SOUNDSUITNOENERGY);
					
				}
				
			}else if(attackerarmorvalue < (GetConVarInt(cvar_suit_strength_jump_energy) < GetConVarInt(cvar_suit_strength_knife_energy) ? GetConVarInt(cvar_suit_strength_jump_energy) : GetConVarInt(cvar_suit_strength_knife_energy))){
				
				//에너지가 부족한 경우
				PrintToChat(attacker, "\x04%T", "suitenergydepleted", attacker);
				setclientsuitfucntion(client, suitmode_charge);
				
				playsuithelpsound(attacker, SOUNDSUITNOENERGY);
				
			}
			
		}
		
	}
	
	//피해자가 실드모드인 경우 방어율을 적용한다
	if(suitmode[client] == suitmode_shield){
		
		if(clientarmorvalue >= 1){
		
			new intdamage = RoundToNearest(damage);
			
			new resultarmor = clientarmorvalue - intdamage;
			
			if(resultarmor >= 0){
				
				intdamage = intdamage / GetConVarInt(cvar_suit_shield_dmgdecrease);
				
				SetEntProp(client, Prop_Data, "m_ArmorValue", clientarmorvalue - intdamage);
				
			}else{
				
				//데미지가 아머에 의해 모두 흡수되지 못한 경우
				//resultarmor가 0이 되는 경우는 위쪽에서 처리햇으므로 음수인 경우만 따지므로 이것을 양수로 바꿔주면 아머가 방어해주지 못한 데미지를 구하는것이다.
				//이때 아머는 0이 아닌 이상 데미지를 흡수했을 것이므로, 이것도 계산해준다.
				
				intdamage = -resultarmor + (clientarmorvalue / GetConVarInt(cvar_suit_shield_dmgdecrease));
				SetEntProp(client, Prop_Data, "m_ArmorValue", 0);
				
			}
			
			if(resultarmor < 1){
				
				//실드모드인데도 더이상 공격을 막을 방탄복이 없다면 자동으로 충전모드
				PrintToChat(client, "\x04%T", "suitenergydepleted", client);
				setclientsuitfucntion(client, suitmode_charge);
				
				cancelreservesuithelpsound(client);
				playsuithelpsound(client, SOUNDSUITNOENERGY);
				
			}
			
			if(intdamage > 0){
			
				damage = float(intdamage);
				
			}else{
				
				damage = 1.0;
				
			}
			
			damagechanged = true;
			
		}else{
			
			//실드모드인데도 공격을 막을 방탄복이 없다면 자동으로 충전모드
			PrintToChat(client, "\x04%T", "suitenergydepleted", client);
			setclientsuitfucntion(client, suitmode_charge);
			
			cancelreservesuithelpsound(client);
			playsuithelpsound(client, SOUNDSUITNOENERGY);
			
		}
		
	}
	
	if(damagechanged){
		
		return Plugin_Changed;
		
	}
	
	return Plugin_Continue;
	
}

public MRESReturn:GetMaxPlayerSpeedPostHook(client, Handle:hReturn){
	
	if(isClientConnectedIngameAlive(client)){
		
		if(suitmode[client] == suitmode_speed){
			
			DHookSetReturn(hReturn, GetConVarFloat(cvar_suit_speed_maxspeed) + GetEntPropFloat(client, Prop_Data, "m_flMaxspeed"));
			return MRES_Override;
			
		}
		
	}
	
	return MRES_Ignored;
	
}

stock createlaserdot(client){
	
	//레이저가 없는 경우
	if(!(laserdotentity[client] != -1 && EntRefToEntIndex(laserdotentity[client]) != -1)){
		
		new envsprite = CreateEntityByName("env_sprite");
		//DispatchKeyValueVector(envsprite,"Origin", resultposition);
		DispatchKeyValue(envsprite, "model", "redglow1.vmt");
		DispatchKeyValue(envsprite, "rendermode", "5");
		DispatchKeyValue(envsprite, "renderfx", "15");
		DispatchSpawn(envsprite);
		AcceptEntityInput(envsprite, "ShowSprite");
			
		laserdotentity[client] = EntIndexToEntRef(envsprite);
		
	}
	
	decl Float:cleyepos[3], Float:cleyeangle[3];
	
	GetClientEyePosition(client, cleyepos); 
	GetClientEyeAngles(client, cleyeangle);
	
	new Handle:traceresulthandle = INVALID_HANDLE;
						
	traceresulthandle = TR_TraceRayFilterEx(cleyepos, cleyeangle, MASK_SOLID, RayType_Infinite, tracerayfilterrocket, client);
						
	if(TR_DidHit(traceresulthandle) == true){
		
		decl Float:resultposition[3], Float:normalvector[3];
		
		TR_GetEndPosition(resultposition, traceresulthandle);
		TR_GetPlaneNormal(traceresulthandle, normalvector);
		NormalizeVector(normalvector, normalvector);
		ScaleVector(normalvector, 5.0);
		AddVectors(resultposition, normalvector, resultposition);
		
		
		TeleportEntity(laserdotentity[client], resultposition, NULL_VECTOR, NULL_VECTOR);
		
	}
	
	CloseHandle(traceresulthandle);
	
}

stock removelaserdot(client){
	
	//레이저가 이미 있는 경우
	if(laserdotentity[client] != 0 && laserdotentity[client] != -1 && EntRefToEntIndex(laserdotentity[client]) != -1){
		
		AcceptEntityInput(laserdotentity[client], "Kill");
		
		laserdotentity[client] = -1;
		
	}
	
}

public Action:WeaponSwitchHook(client, entity){
	
	if(isClientConnectedIngame(client)){
	
		//기능 초기화
		abilitybuffer[client] = ABILITY_NONE;
		chargingenergyball[client] = false;
		
		//어느 무기로 바꾸는지 확인해서 해당 무기가 쓸 수 있는 특수기술의 플래그를 저장한다
		if(entity != -1){
		
			abilitybuffer[client] = getweaponability(client, entity);
			
		}
		
	}
	
	return Plugin_Continue;
	
}

public Action:WeaponDropHook(client, entity){
	
	if((isClientConnectedIngame(client) && entity != -1) && GetConVarBool(cvar_enable_weapon_transparency_adjust)){
	
		SetEntityRenderMode(entity, RENDER_NORMAL);
		SetEntityRenderColor(entity, 255, 255, 255, 255);
		
	}
	
	return Plugin_Continue;
	
}

public selectormenu(client){
	
	new Handle:menuhandle = CreateMenu(selectormenuhandler);
	
	decl String:txt[64], String:typestring[32];
	
	Format(txt, 64, "%T", "gunselectormenutitle", client);
	SetMenuTitle(menuhandle, txt);
	
	Format(txt, 64, "%T", "gunselectormenudisable", client);
	AddMenuItem(menuhandle, txt, txt);
	
	if(abilitybuffer[client] & ABILITY_GRENADE){
		
		Format(txt, 64, "%T", "gunselectormenugrenade", client);
		IntToString(ABILITY_GRENADE, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
		
	}
	
	if(abilitybuffer[client] & ABILITY_ENERGYBALL){
	
		Format(txt, 64, "%T", "gunselectormenuenergyball", client);
		IntToString(ABILITY_ENERGYBALL, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
		
	}
	
	if(abilitybuffer[client] & ABILITY_specialgrenade){
	
		Format(txt, 64, "%T", "gunselectormenuspecialgrenade", client);
		IntToString(ABILITY_specialgrenade, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
		
		if((abilitybuffer[client] & ABILITY_specialgrenadeDETONATE) && GetConVarBool(cvar_specialgrenade_remote_detonate)){
			
			Format(txt, 64, "%T", "gunselectormenuspecialgrenadedetonate", client);
			IntToString(ABILITY_specialgrenadeDETONATE, typestring, 32);
			AddMenuItem(menuhandle, typestring, txt);
			
		}
			
	}
	
	if(abilitybuffer[client] & ABILITY_MINE){
	
		Format(txt, 64, "%T", "gunselectormenumine", client);
		IntToString(ABILITY_MINE, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
		
	}
	
	if(abilitybuffer[client] & ABILITY_SENSOR){
	
		Format(txt, 64, "%T", "gunselectormenusensor", client);
		IntToString(ABILITY_SENSOR, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
		
	}
	
	if(abilitybuffer[client] & ABILITY_ROCKET){
	
		Format(txt, 64, "%T", "gunselectormenurocket", client);
		IntToString(ABILITY_ROCKET, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
		
	}
	
	if(abilitybuffer[client] & ABILITY_HEAL){
	
		Format(txt, 64, "%T", "gunselectormenuheal", client);
		IntToString(ABILITY_HEAL, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
		
	}
	
	if(abilitybuffer[client] & ABILITY_EMP){
	
		Format(txt, 64, "%T", "gunselectormenuemp", client);
		IntToString(ABILITY_EMP, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
		
	}
	
	SetMenuPagination(menuhandle, MENU_NO_PAGINATION);
	SetMenuExitButton(menuhandle, true);
	
	DisplayMenu(menuhandle, client, MENU_TIME_FOREVER);
	
}

public selectormenuhandler(Handle:menu, MenuAction:action, client, select){
	
	if(action == MenuAction_Select){
		
		if(isClientConnectedIngameAlive(client)){
		
			new String:infobuffer[64], String:displaybuffer[64], style;
			GetMenuItem(menu, select, infobuffer, 64, style, displaybuffer, 64);
			
			new selectedtype = StringToInt(infobuffer); 
			
			if(select == 0){
				
				if(abilitybuffer[client] >= ABILITY_BULLET){
				
					PrintToChat(client, "\x04%T", "gunselector-disable", client);
					gunselectormode[client] = selector_bullet;
					
				}else{
					
					PrintToChat(client, "\x04%T", "gunselector-notsupported", client);
					
				}
				
			}else{
				
				if(abilitybuffer[client] >= ABILITY_BULLET){
	
					if(abilitybuffer[client] & selectedtype){
					
						if(selectedtype == ABILITY_GRENADE){
							
							PrintToChat(client, "\x04%T", "gunselector-grenade", client);
							gunselectormode[client] = selector_grenade;
							
						}else if(selectedtype == ABILITY_ENERGYBALL){
							
							PrintToChat(client, "\x04%T", "gunselector-energyball", client);
							gunselectormode[client] = selector_energyball;
							
						}else if(selectedtype == ABILITY_MINE){
							
							PrintToChat(client, "\x04%T", "gunselector-mine", client);
							gunselectormode[client] = selector_mine;
							
						}else if(selectedtype == ABILITY_SENSOR){
							
							PrintToChat(client, "\x04%T", "gunselector-sensor", client);
							gunselectormode[client] = selector_sensor;
							
						}else if(selectedtype == ABILITY_ROCKET){
							
							PrintToChat(client, "\x04%T", "gunselector-rocket", client);
							gunselectormode[client] = selector_rocket;
							
						}else if(selectedtype == ABILITY_HEAL){
							
							PrintToChat(client, "\x04%T", "gunselector-heal", client);
							gunselectormode[client] = selector_heal;
							
						}else if(selectedtype == ABILITY_EMP){
							
							PrintToChat(client, "\x04%T", "gunselector-emp", client);
							gunselectormode[client] = selector_emp;
							
						}else if(selectedtype == ABILITY_specialgrenade){
							
							PrintToChat(client, "\x04%T", "gunselector-specialgrenade", client);
							gunselectormode[client] = selector_specialgrenade;
							
						}else if(selectedtype == ABILITY_specialgrenadeDETONATE){
							
							//모든 특수 유탄을 폭발시킨다
							PrintToChat(client, "\x04%T", "remotedetonatespecialgrenade", client);
							
							detonateSpecialGrenade(client, false);
							
						}
						
					}else{
						
						PrintToChat(client, "\x04%T", "gunselector-notsupported", client);
						
					}
				
				}else{
					
					PrintToChat(client, "\x04%T", "gunselectornoselector", client);
					
				}
				
			}
			
		}
		
	}else if(action == MenuAction_Cancel){
			
		if(select == MenuCancel_Exit){
			
			
			
		}
		
	}else if(action == MenuAction_End){
			
		CloseHandle(menu);
		
	}else if(action == MenuAction_DisplayItem){
		
		decl String:display[64];
		GetMenuItem(menu, select, "", 0, _, display, sizeof(display));
		decl String:buffer[255];
		Format(buffer, sizeof(buffer), "%T", display, client);
		//return RedrawMenuItem(buffer);
		
	}else if(action == MenuAction_Display){
		
		new Handle:panel = Handle:select;
		decl String:buffer[255];
		Format(buffer, sizeof(buffer), "%T", "gunselectormenutitle", client);
		SetPanelTitle(panel, buffer);
	
	}
	
}

specialattack(client){
	
	if((gunselectormode[client] == selector_grenade) && (abilitybuffer[client] & ABILITY_GRENADE)){
		
		//유탄발사
		grenadeattack(client);
		
	}else if((gunselectormode[client] == selector_rocket) && (abilitybuffer[client] & ABILITY_ROCKET)){
		
		rocketattack(client);
		
	}else if((gunselectormode[client] == selector_mine) && (abilitybuffer[client] & ABILITY_MINE)){
		
		mineattack(client);
		
	}else if((gunselectormode[client] == selector_sensor) && (abilitybuffer[client] & ABILITY_SENSOR)){
		
		sensorattack(client);
		
	}else if((gunselectormode[client] == selector_heal) && (abilitybuffer[client] & ABILITY_HEAL)){
		
		healattack(client);
		
	}else if((gunselectormode[client] == selector_energyball) && (abilitybuffer[client] & ABILITY_ENERGYBALL)){
		
		if(!chargingenergyball[client]){
		
			energyballattack(client);
			
		}
		
	}else if((gunselectormode[client] == selector_emp) && (abilitybuffer[client] & ABILITY_EMP)){
		
		empattack(client);
		
	}else if((gunselectormode[client] == selector_specialgrenade) && (abilitybuffer[client] & ABILITY_specialgrenade)){
	
		specialgrenadeattack(client);
			
	}
	
}

public Action:EventSpawn(Handle:Event, const String:Name[], bool:Broadcast){
	
	decl client;
	client = GetClientOfUserId(GetEventInt(Event, "userid"));
	
	new clientteam = GetClientTeam(client);
	
	if(clientteam == CS_TEAM_CT || clientteam == CS_TEAM_T){
	
		suitmode[client] = suitmode_none;
		gunselectormode[client] = selector_default;
		specialskillmode[client] = skilltype_none;
		chargingenergyball[client] = false;
		nextsuitactivetime[client] = GetGameTime() + GetConVarFloat(cvar_suit_cloak_energy_delay);
		nextsensoractivetime[client] = GetEngineTime() + GetConVarFloat(cvar_sensor_show_delay);
		nextcloakactivetime[client] = GetGameTime() + GetConVarFloat(cvar_suit_cloak_change_delay);
		nextsuitsensortime[client] = GetGameTime() + GetConVarFloat(cvar_suit_sensor_delay);
		nextsuithelpsound[client] = GetGameTime();
		cloakalpha[client] = 255;
		cancelreservesuithelpsound(client);
		
		for(new i = 0; i < MAX_SELECTTYPE;i++){
		
			gunfunctionlimit[client][i] = 0;
			
		}
		
		for(new i = 1; i <= MaxClients; i++){
		
			detectedbysensor[client][i] = false;
			
		}
		
		new String:helpmsg[512];
		
		Format(helpmsg, 512, "%T", "spawnhelp1", client);
		
		if(teamcanusesuitfunctionmenu(clientteam)){
			
			Format(helpmsg, 512, "%s %T", helpmsg, "spawnhelp2", client);
			
		}
		if(teamcanusespecialskill[skilltype_none][clientteam]){
			
			Format(helpmsg, 512, "%s %T", helpmsg, "spawnhelp3", client);
			
		}
		Format(helpmsg, 512, "%s %T", helpmsg, "spawnhelp4", client);
		
		PrintToChat(client, "\x04%s", helpmsg);
		
		PrintToChat(client, "\x04%T", "gunselector-disable", client);
		
		if(teamcanusespecialskill[skilltype_none][clientteam]){
			
			PrintToChat(client, "\x04%T", "specialskill-disable", client);
			
		}
		
		setclientsuitfucntion(client, suitmode_charge, false);
		
	}
	
}

public Action:EventHurt(Handle:Event, const String:Name[], bool:Broadcast){
	
	decl client, health;
	client = GetClientOfUserId(GetEventInt(Event, "userid"));
	health = GetEventInt(Event, "health");
	
	if(health >= 80){
		
		cancelreservesuithelpsound(client);
		playsuithelpsound(client, SOUNDSUITBLOODLOSS);
		reservesuithelpsound(5.0, client, SOUNDSUITFINEMEDIC);
		
	}else if(health >= 60){
		
		cancelreservesuithelpsound(client);
		playsuithelpsound(client, SOUNDSUITHEALTHDROP1);
		reservesuithelpsound(5.0, client, SOUNDSUITFINEMEDIC);
				
	}else if(health >= 40){
		
		cancelreservesuithelpsound(client);
		playsuithelpsound(client, SOUNDSUITHEALTHDROP2);
		reservesuithelpsound(5.0, client, SOUNDSUITFINEMEDIC);
		
	}else if(health >= 20){
		
		cancelreservesuithelpsound(client);
		playsuithelpsound(client, SOUNDSUITHEALTHCRITICAL);
		reservesuithelpsound(5.0, client, SOUNDSUITFINEMEDIC);
		
	}else if(health >= 1){
		
		cancelreservesuithelpsound(client);
		playsuithelpsound(client, SOUNDSUITNEARDEATH);
		reservesuithelpsound(5.0, client, SOUNDSUITFINEMEDIC);
		
	}
	
}

public Action:EventDeath(Handle:Event, const String:Name[], bool:Broadcast){
	
	decl client, attacker;

	client = GetClientOfUserId(GetEventInt(Event, "userid"));
	attacker = GetClientOfUserId(GetEventInt(Event, "attacker"));
	
	if(client != 0){
		
		kills[client] = 0;
		
		cancelreservesuithelpsound(client);
		
		playsuithelpsound(client, SOUNDSUITDEATH, true);
		
		if(GetConVarFloat(cvar_specialgrenade_life_time) <= 0.0){
		
			//detonate without damage
			detonateSpecialGrenade(client, true);
		
		}
		
		decl String:weapon[64];
		GetEventString(Event, "weapon", weapon, 64);
		
		if(StrEqual(weapon, ENERGYBALL_WEAPONNAME, false)){
			
			new ragdoll = GetEntPropEnt(client, Prop_Send, "m_hRagdoll");
			
			if(ragdoll != -1){
				
				decl String:tarnetname[64];
				Format(tarnetname, 64, "%f%f", GetEngineTime(), GetRandomFloat());

				new dissolver = CreateEntityByName("env_entity_dissolver");
				
				if(dissolver != -1){
					
					DispatchKeyValue(ragdoll, "targetname", tarnetname);
					DispatchKeyValue(dissolver, "dissolvetype", "3");
					DispatchKeyValue(dissolver, "target", tarnetname);
					AcceptEntityInput(dissolver, "Dissolve");
					AcceptEntityInput(dissolver, "kill");
					
				}
				
			}
			
		}
		
	}
	
	if(attacker != 0){
		
		if((GetClientTeam(client) != GetClientTeam(attacker)) && isClientConnectedIngameAlive(attacker)){
		
			decl String:weapon[32];
			GetEventString(Event, "weapon", weapon, 32);
		
			if(!(StrEqual(weapon, NUKE_WEAPONNAME) && NOKILLSFROMNUKE)){
			
				kills[attacker]++;
			
				decl String:name[64];
				GetClientName(attacker, name, 64);
				
				if(teamcanusespecialskill[skilltype_none][GetClientTeam(attacker)]){
				
					if(kills[attacker] == killsforspecialskill[skilltype_nuke] && teamcanusespecialskill[skilltype_nuke][GetClientTeam(attacker)]){
						
						PrintCenterTextAll("%T", "killstreaknuke", client, name, killsforspecialskill[skilltype_nuke]);
						
						//이곳에 폭격 사용 가능 소리가 온다
						for(new i = 1; i <= MaxClients; i++){
							
							if(isClientConnectedIngame(i))playsoundfromclient(i, SOUNDNUKEREADY);
							
						}
						
					}
					
				}
				
			}
			
		}
			
	}
	
}

public Action:EventWeaponFire(Handle:Event, const String:Name[], bool:Broadcast){
	
	decl client;

	client = GetClientOfUserId(GetEventInt(Event, "userid"));
	
	if(isClientConnectedIngameAlive(client)){
		
		CloakingDisable(client);
		
	}
	
}

public Action:EventEmptyShot(Handle:Event, const String:Name[], bool:Broadcast){
	
	decl client;

	client = GetClientOfUserId(GetEventInt(Event, "userid"));
	
	cancelreservesuithelpsound(client);
	playsuithelpsound(client, SOUNDSUITNOAMMO);
	
}

stock grenadeattack(client){
	
	//유탄을 발사한다
	
	new usingweapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
	
	if(usingweapon != -1){
			
		//탄환이 충분하고, 재장전이 끝났고, 무기의 다음 공격시간이 유효하고, 플레이어의 다음 공격시간이 유효한가 확인,
		//이것들을 하나라도 빠트리면 버그가 생겼다
		new ammo = GetEntProp(usingweapon, Prop_Data, "m_iClip1");
		
		if(ammo >= gunfunctionammo(client, selector_grenade)
			&& !GetEntProp(usingweapon, Prop_Data, "m_bInReload")
			&& GetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack") <= GetGameTime()
			&& GetEntPropFloat(client, Prop_Data, "m_flNextAttack") <= GetGameTime()){
			
			if(useleftgunfunction(client, selector_grenade)){
				
				//탄환이 충분하므로 탄환을 줄이고 발사를 시작한다
				SetEntProp(usingweapon, Prop_Data, "m_iClip1", ammo - gunfunctionammo(client, selector_grenade));
				//다음 공격 시간을 늧춘다
				SetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack", FloatAdd(GetGameTime(), getgunfunctioncooltime(selector_grenade)));
				
				decl Float:clienteyeangle[3], Float:anglevector[3], Float:clienteyeposition[3], Float:resultposition[3], entity;
				GetClientEyeAngles(client, clienteyeangle);
				GetClientEyePosition(client, clienteyeposition);
				GetAngleVectors(clienteyeangle, anglevector, NULL_VECTOR, NULL_VECTOR);
				NormalizeVector(anglevector, anglevector);
				//ScaleVector(anglevector, 10.0);
				AddVectors(clienteyeposition, anglevector, resultposition);
				NormalizeVector(anglevector, anglevector);
				ScaleVector(anglevector, GetConVarFloat(cvar_grenade_projectile_speed));
				
				//이제 중요한 것 하나, 플레이어의 이동속도를 유탄의 속도에 더해야한다.
				//현실성은 중요한것
				decl Float:playerspeed[3];
				GetEntPropVector(client, Prop_Data, "m_vecVelocity", playerspeed);
				AddVectors(anglevector, playerspeed, anglevector);
				
				entity = CreateEntityByName("hegrenade_projectile");
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				setTakeDamage(entity, DAMAGE_NO);
				DispatchSpawn(entity);
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				SetEntityModel(entity, "models/Items/ar2_grenade.mdl");//유탄
				//소리
				playsound(client, SOUNDTYPEGRENADE_LAUNCHER1, clienteyeposition);
				//유탄이 닿는 순간 터지게 하기 위한 훅
				SDKHook(entity, SDKHook_StartTouch, GrenadeTouchHook);
				//유탄이 공격당하는 순간 터지게 하기 위한 훅
				SDKHook(entity, SDKHook_OnTakeDamage, GrenadeDamageHook);
				
				setTakeDamage(entity, DAMAGE_YES);
				TeleportEntity(entity, resultposition, clienteyeangle, anglevector);
				
				new gascloud = CreateEntityByName("env_smoketrail");
				DispatchKeyValueVector(gascloud,"Origin", resultposition);
				DispatchKeyValueVector(gascloud,"Angles", clienteyeangle);
				new Float:smokecolor[3] = {1.0, 1.0, 1.0};
				new Float:endcolor[3] = {0.0, 0.0, 0.0};
				SetEntPropVector(gascloud, Prop_Send, "m_StartColor", smokecolor);
				SetEntPropVector(gascloud, Prop_Send, "m_EndColor", endcolor);
				SetEntPropFloat(gascloud, Prop_Send, "m_Opacity", 0.2);
				SetEntPropFloat(gascloud, Prop_Send, "m_SpawnRate", 48.0);
				SetEntPropFloat(gascloud, Prop_Send, "m_ParticleLifetime", 1.0);
				SetEntPropFloat(gascloud, Prop_Send, "m_StartSize", 5.0);
				SetEntPropFloat(gascloud, Prop_Send, "m_EndSize", 30.0);
				SetEntPropFloat(gascloud, Prop_Send, "m_SpawnRadius", 0.0);
				SetEntPropFloat(gascloud, Prop_Send, "m_MinSpeed", 0.0);
				SetEntPropFloat(gascloud, Prop_Send, "m_MaxSpeed", 10.0);
				DispatchSpawn(gascloud);
				SetVariantString("!activator");
				AcceptEntityInput(gascloud, "SetParent", entity);
				SetEntPropEnt(entity, Prop_Send, "m_hEffectEntity", gascloud);
				
				CloakingDisable(client);
				
				makecustumviewpunch(client, selector_grenade);
				
			}
			
		}
		
	}
	
}

public Action:GrenadeTouchHook(entity, other){
	
	if(other != 0){
		
		//발사한 사람의 몸에 닿더라도 터져서는 안된다
		if(other == GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity")){
			
			return Plugin_Continue;
			
		}else{
		
			//닿아서 터져야 하는 것들의 목록 중에 단 한개도 일치하지 않는 경우
			if(!IsEntityCollidable(other, true, true, true)){
				
				return Plugin_Continue;
				
			}
			
		}
			
	}
	
	GrenadeActive(entity);
	
	return Plugin_Continue;
	
}

public Action:GrenadeDamageHook(entity, &attacker, &inflictor, &Float:damage, &damagetype){
	
	if(GetEntProp(entity, Prop_Data, "m_takedamage") == DAMAGE_YES){
	
		GrenadeActive(entity);
		
	}
	
	return Plugin_Continue;
	
}

stock GrenadeActive(entity){
	
	//유탄이 닿는 순간 터지게 하기 위한 훅
	SDKUnhook(entity, SDKHook_StartTouch, GrenadeTouchHook);
	//유탄이 공격당하는 순간 터지게 하기 위한 훅
	SDKUnhook(entity, SDKHook_OnTakeDamage, GrenadeDamageHook);
	
	if(GetEntProp(entity, Prop_Data, "m_takedamage") == DAMAGE_YES){
	
		setTakeDamage(entity, DAMAGE_NO);//더이상 데미지를 안 입게 한다
		decl Float:entityposition[3];
		GetEntPropVector(entity, Prop_Send, "m_vecOrigin", entityposition);
		new client = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
		new gasentity = GetEntPropEnt(entity, Prop_Send, "m_hEffectEntity");//가스엔티티를 구한다
		AcceptEntityInput(gasentity, "Kill");
		entityposition[2] = entityposition[2] + 10.0;//폭발을 약간 위쪽으로, 데미지를 제대로 주기 위한 수단
		//폭발을 일으킨다
		makeExplosion(isClientConnectedIngame(client) ? client : 0, entity, entityposition, GRENADE_WEAPONNAME, GetConVarInt(cvar_grenade_damage), GetConVarInt(cvar_grenade_dmg_radius));
		//폭발음을 일으킨다
		playsound(0, SOUNDTYPEEXPLODE, entityposition);
		//유탄 엔티티 제거
		AcceptEntityInput(entity, "Kill");
		
	}
	
}

stock rocketattack(client){
	
	//로켓을 발사한다
	
	new usingweapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
	
	if(usingweapon != -1){
			
		//탄환이 충분하고, 재장전이 끝났고, 무기의 다음 공격시간이 유효하고, 플레이어의 다음 공격시간이 유효한가 확인,
		//이것들을 하나라도 빠트리면 버그가 생겼다
		new ammo = GetEntProp(usingweapon, Prop_Data, "m_iClip1");
		
		if(ammo >= gunfunctionammo(client, selector_rocket)
			&& !GetEntProp(usingweapon, Prop_Data, "m_bInReload")
			&& GetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack") <= GetGameTime()
			&& GetEntPropFloat(client, Prop_Data, "m_flNextAttack") <= GetGameTime()){
			
			if(useleftgunfunction(client, selector_rocket)){
				
				//탄환이 충분하므로 탄환을 줄이고 발사를 시작한다
				SetEntProp(usingweapon, Prop_Data, "m_iClip1", ammo - gunfunctionammo(client, selector_rocket));
				//다음 공격 시간을 늧춘다
				SetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack", FloatAdd(GetGameTime(), getgunfunctioncooltime(selector_rocket)));
				
				decl Float:clienteyeangle[3], Float:anglevector[3], Float:clienteyeposition[3], Float:resultposition[3], entity;
				GetClientEyeAngles(client, clienteyeangle);
				GetClientEyePosition(client, clienteyeposition);
				GetAngleVectors(clienteyeangle, anglevector, NULL_VECTOR, NULL_VECTOR);
				NormalizeVector(anglevector, anglevector);
				//ScaleVector(anglevector, 10.0);
				AddVectors(clienteyeposition, anglevector, resultposition);
				NormalizeVector(anglevector, anglevector);
				ScaleVector(anglevector, GetConVarFloat(cvar_rocket_projectile_speed));
				
				entity = CreateEntityByName("hegrenade_projectile");
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				setTakeDamage(entity, DAMAGE_NO);
				DispatchSpawn(entity);
				new Float:vecmax[3] = {4.0, 4.0, 4.0};
				new Float:vecmin[3] = {-4.0, -4.0, -4.0};
				SetEntPropVector(entity, Prop_Send, "m_vecMins", vecmin);
				SetEntPropVector(entity, Prop_Send, "m_vecMaxs", vecmax);
				SetEntityMoveType(entity, MOVETYPE_FLY);//중력 영향 안받음
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				SetEntityModel(entity, "models/weapons/w_missile_launch.mdl");//미사일
				TeleportEntity(entity, resultposition, clienteyeangle, anglevector);
				
				new gascloud = CreateEntityByName("env_rockettrail");
				DispatchKeyValueVector(gascloud,"Origin", resultposition);
				DispatchKeyValueVector(gascloud,"Angles", clienteyeangle);
				new Float:smokecolor[3] = {1.0, 1.0, 1.0};
				SetEntPropVector(gascloud, Prop_Send, "m_StartColor", smokecolor);
				SetEntPropFloat(gascloud, Prop_Send, "m_Opacity", 0.5);
				SetEntPropFloat(gascloud, Prop_Send, "m_SpawnRate", 100.0);
				SetEntPropFloat(gascloud, Prop_Send, "m_ParticleLifetime", 0.5);
				SetEntPropFloat(gascloud, Prop_Send, "m_StartSize", 5.0);
				SetEntPropFloat(gascloud, Prop_Send, "m_EndSize", 30.0);
				SetEntPropFloat(gascloud, Prop_Send, "m_SpawnRadius", 0.0);
				SetEntPropFloat(gascloud, Prop_Send, "m_MinSpeed", 0.0);
				SetEntPropFloat(gascloud, Prop_Send, "m_MaxSpeed", 10.0);
				SetEntPropFloat(gascloud, Prop_Send, "m_flFlareScale", 1.0);
				DispatchSpawn(gascloud);
				decl String:steamid[64];
				GetClientAuthString(client, steamid, 64);
				Format(steamid, 64, "%s%f", steamid, GetGameTime());
				DispatchKeyValue(entity, "targetname", steamid);
				SetVariantString(steamid);
				AcceptEntityInput(gascloud, "SetParent");
				SetEntPropEnt(entity, Prop_Send, "m_hEffectEntity", gascloud);
				
				//소리
				playsound(client, SOUNDTYPEROCKETFIRE1, clienteyeposition);
				playingrocketsound[entity] = true;
				playentitysound(entity, SOUNDROCKET1, resultposition);
				//미사일이 닿는 순간 터지게 하기 위한 훅
				SDKHook(entity, SDKHook_StartTouch, RocketTouchHook);
				//미사일이 공격당하는 순간 터지게 하기 위한 훅
				SDKHook(entity, SDKHook_OnTakeDamage, RocketDamageHook);
				
				//미사일의 유도를 위한 함수를 위한 정보
				new Handle:datapack = CreateDataPack();
				//이 미사일의 엔티티 레퍼런스를 담아둔다
				WritePackCell(datapack, EntIndexToEntRef(entity));
				//바로 실행되는 타이머
				CreateTimer(0.1, RocketSeekThink, datapack, TIMER_REPEAT | TIMER_FLAG_NO_MAPCHANGE | TIMER_DATA_HNDL_CLOSE);
				setTakeDamage(entity, DAMAGE_YES);
				
				CloakingDisable(client);
				
				makecustumviewpunch(client, selector_rocket);
				
			}
			
		}
		
	}
	
}

public Action:RocketTouchHook(entity, other){
	
	if(other != 0){
		
		//발사한 사람의 몸에 닿더라도 터져서는 안된다
		if(other == GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity")){
			
			return Plugin_Continue;
			
		}else{
			
			//닿아서 터져야 하는 것들의 목록 중에 단 한개도 일치하지 않는 경우
			if(!IsEntityCollidable(other, true, true, true)){
				
				return Plugin_Continue;
				
			}
			
		}
			
	}
	
	RocketActive(entity);
	
	return Plugin_Continue;
	
}

public Action:RocketDamageHook(entity, &attacker, &inflictor, &Float:damage, &damagetype){
	
	if(GetEntProp(entity, Prop_Data, "m_takedamage") == DAMAGE_YES){
	
		RocketActive(entity);
		
	}
	
	return Plugin_Continue;
	
}

//로켓의 유도코드
public Action:RocketSeekThink(Handle:Timer, Handle:data){
	
	//리셋팩
	decl entity, client;
	ResetPack(data);
	entity = ReadPackCell(data);
	entity = EntRefToEntIndex(entity);
	
	//미사일엔티티가 존재한다
	if(entity != -1){
	
		client = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
		
		//클라이언트가 아직 살아있는가? 살아있지 않다면, 유도를 중단하고 곧장 날아간다.
		if(isClientConnectedIngame(client)){
			
			//접속해 있고 살아있는 경우
			if(IsPlayerAlive(client)){
				
				//현재 꺼내든 무기가 유도로켓 기능이 있는가?
				if(abilitybuffer[client] & ABILITY_ROCKET && gunselectormode[client] == selector_rocket){
					
					//플레이어가 바라보는 곳의 위치를 구하고, 로켓의 위치로부터 그 위치로까지의 각도를 구해서 그 각도로 향하게 각도 조절
					decl Float:cleyepos[3], Float:cleyeangle[3], Float:resultposition[3], Float:rocketposition[3], Float:vecangle[3], Float:angle[3];
					
					GetClientEyePosition(client, cleyepos); 
					GetClientEyeAngles(client, cleyeangle);
					
					new Handle:traceresulthandle = INVALID_HANDLE;
										
					traceresulthandle = TR_TraceRayFilterEx(cleyepos, cleyeangle, MASK_SOLID, RayType_Infinite, tracerayfilterrocket, client);
										
					if(TR_DidHit(traceresulthandle) == true){
						
						TR_GetEndPosition(resultposition, traceresulthandle);
						GetEntPropVector(entity, Prop_Send, "m_vecOrigin", rocketposition);
						//로켓포지션에서 추적 위치로 가는 벡터를 구한다
						MakeVectorFromPoints(rocketposition, resultposition, vecangle);
						NormalizeVector(vecangle, vecangle);
						GetVectorAngles(vecangle, angle);
						ScaleVector(vecangle, GetConVarFloat(cvar_rocket_projectile_speed));
						TeleportEntity(entity, NULL_VECTOR, angle, vecangle);
						
					}
					
					CloseHandle(traceresulthandle);
						
				}
				
			}
			
		}
		
		return Plugin_Continue;
		
	}else{
		
		return Plugin_Stop;
		
	}
	
}

stock RocketActive(entity){
	
	//미사일이 닿는 순간 터지게 하기 위한 훅
	SDKUnhook(entity, SDKHook_StartTouch, RocketTouchHook);
	//미사일이 공격당하는 순간 터지게 하기 위한 훅
	SDKUnhook(entity, SDKHook_OnTakeDamage, RocketDamageHook);
	
	if(GetEntProp(entity, Prop_Data, "m_takedamage") == DAMAGE_YES){
	
		setTakeDamage(entity, DAMAGE_NO);//더이상 데미지를 안 입게 한다
		decl Float:entityposition[3];
		GetEntPropVector(entity, Prop_Send, "m_vecOrigin", entityposition);
		new client = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
		//가스 엔티티 제거
		new gasentity = GetEntPropEnt(entity, Prop_Send, "m_hEffectEntity");//가스엔티티를 구한다
		AcceptEntityInput(gasentity, "kill");
		entityposition[2] = entityposition[2] + 10.0;
		//폭발을 일으킨다
		makeExplosion(isClientConnectedIngame(client) ? client : 0, entity, entityposition, ROCKET_WEAPONNAME, GetConVarInt(cvar_rocket_damage), GetConVarInt(cvar_rocket_dmg_radius));
		//폭발음을 일으킨다
		playsound(0, SOUNDTYPEEXPLODE, entityposition);
		AcceptEntityInput(entity, "Kill");//로켓엔티티제거
		
	}
	
}

//힐
stock healattack(client){
	
	new usingweapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
	
	if(usingweapon != -1){
			
		//탄환이 충분하고, 재장전이 끝났고, 무기의 다음 공격시간이 유효하고, 플레이어의 다음 공격시간이 유효한가 확인,
		//이것들을 하나라도 빠트리면 버그가 생겼다
		new ammo = GetEntProp(usingweapon, Prop_Data, "m_iClip1");
		
		if(ammo >= gunfunctionammo(client, selector_heal)
			&& !GetEntProp(usingweapon, Prop_Data, "m_bInReload")
			&& GetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack") <= GetGameTime()
			&& GetEntPropFloat(client, Prop_Data, "m_flNextAttack") <= GetGameTime()){
			
			if(useleftgunfunction(client, selector_heal)){
				
				//조준선에 있는 아군 클라이언트를 찾아내서 거리가 100 이하라면 체력을 판단한 뒤 치료와 함께 이펙트
				decl Float:cleyepos[3], Float:cleyeangle[3], Float:resultposition[3];
						
				GetClientEyePosition(client, cleyepos);
				GetClientEyeAngles(client, cleyeangle);
				
				new Handle:traceresulthandle = INVALID_HANDLE;
									
				traceresulthandle = TR_TraceRayFilterEx(cleyepos, cleyeangle, MASK_SOLID, RayType_Infinite, tracerayfilterdefault, client);
									
				if(TR_DidHit(traceresulthandle) == true){
					
					TR_GetEndPosition(resultposition, traceresulthandle);
					new target = TR_GetEntityIndex(traceresulthandle);
					
					if(isClientConnectedIngameAlive(target) && GetClientTeam(target) == GetClientTeam(client)){
						
						//다음 공격 시간을 늧춘다
						SetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack", FloatAdd(GetGameTime(), getgunfunctioncooltime(selector_heal)));
						
						if(200 >= GetVectorDistance(cleyepos, resultposition)){
							
							new targethealth = GetEntProp(target, Prop_Data, "m_iHealth");
							
							if(targethealth < 100){
								
								//치료를 해야한다
								//탄환이 충분하므로 탄환을 줄인다
								SetEntProp(usingweapon, Prop_Data, "m_iClip1", ammo - gunfunctionammo(client, selector_heal));
								
								new maxhealth = GetEntProp(target, Prop_Data, "m_iMaxHealth");
								
								if(targethealth + GetConVarInt(cvar_heal_per_time) >= maxhealth){
									
									SetEntProp(target, Prop_Data, "m_iHealth", maxhealth);
									
								}else{
									
									SetEntProp(target, Prop_Data, "m_iHealth", targethealth + GetConVarInt(cvar_heal_per_time));
									
								}
								
								//이펙트를 만든다
								playsound(client, SOUNDTYPEHEAL, cleyepos);
								
							}else{
								
								playsound(client, SOUNDTYPENOHEAL, cleyepos);
								
							}
							
						}
						
					}
					
				}
				
				CloseHandle(traceresulthandle);
				
			}
			
		}
		
	}
	
}

stock energyballattack(client){
	
	new usingweapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
	
	if(usingweapon != -1){
			
		//탄환이 충분하고, 재장전이 끝났고, 무기의 다음 공격시간이 유효하고, 플레이어의 다음 공격시간이 유효한가 확인,
		//이것들을 하나라도 빠트리면 버그가 생겼다
		new ammo = GetEntProp(usingweapon, Prop_Data, "m_iClip1");
		
		if(ammo >= gunfunctionammo(client, selector_energyball)
			&& !GetEntProp(usingweapon, Prop_Data, "m_bInReload")
			&& GetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack") <= GetGameTime()
			&& GetEntPropFloat(client, Prop_Data, "m_flNextAttack") <= GetGameTime()){
			
			new leftenergyball = getleftgunfunction(client, selector_energyball);
				
			if(leftenergyball != 0){
				
				//에너지볼 발사 모드를 참으로 한다
				chargingenergyball[client] = true;
				SetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack", FloatAdd(GetGameTime(), GetConVarFloat(cvar_energyball_fire_charge_time)));
				
				decl Float:clienteyeposition[3];
				GetClientEyePosition(client, clienteyeposition);
				playsound(client, SOUNDTYPEENERGYBALLCHARGE, clienteyeposition);
				
			}else if(leftenergyball == 0){
				
				//keybuffer!!! this prevents overflow of exceed message
				keybuffer[client] = keybuffer[client] | IN_USE;
				//이 시점에선 에너지볼을 소모하지 않으므로, 남은 에너지볼 관련 문구는 출력할 이유가 없다
				PrintToChat(client, "\x04%T", "energyballlimitexceed", client);
				
			}
			
		}
		
	}
	
}

stock fireenergyball(client){
	
	new usingweapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
	
	if(usingweapon != -1){
			
		//탄환이 충분하고, 재장전이 끝났고, 무기의 다음 공격시간이 유효하고, 플레이어의 다음 공격시간이 유효한가 확인,
		//이것들을 하나라도 빠트리면 버그가 생겼다
		new ammo = GetEntProp(usingweapon, Prop_Data, "m_iClip1");
		
		if(ammo >= gunfunctionammo(client, selector_energyball)
			&& !GetEntProp(usingweapon, Prop_Data, "m_bInReload")
			&& GetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack") <= GetGameTime()
			&& GetEntPropFloat(client, Prop_Data, "m_flNextAttack") <= GetGameTime()){
			
			if(useleftgunfunction(client, selector_energyball)){
				
				//에너지볼 발사 모드를 거짓으로 한다
				chargingenergyball[client] = false;
				SetEntProp(usingweapon, Prop_Data, "m_iClip1", ammo - gunfunctionammo(client, selector_energyball));
				SetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack", FloatAdd(GetGameTime(), getgunfunctioncooltime(selector_energyball)));
				
				//에너지볼을 발사한다
				decl Float:clienteyeangle[3], Float:anglevector[3], Float:clienteyeposition[3], Float:resultposition[3], entity;
				GetClientEyeAngles(client, clienteyeangle);
				GetClientEyePosition(client, clienteyeposition);
				GetAngleVectors(clienteyeangle, anglevector, NULL_VECTOR, NULL_VECTOR);
				NormalizeVector(anglevector, anglevector);
				ScaleVector(anglevector, 10.0);
				AddVectors(clienteyeposition, anglevector, resultposition);
				NormalizeVector(anglevector, anglevector);
				ScaleVector(anglevector, GetConVarFloat(cvar_energyball_projectile_speed));
				
				//이제 중요한 것 하나, 플레이어의 이동속도를 유탄의 속도에 더해야한다.
				//현실성은 중요한것
				decl Float:playerspeed[3];
				GetEntPropVector(client, Prop_Data, "m_vecVelocity", playerspeed);
				AddVectors(anglevector, playerspeed, anglevector);
				
				entity = CreateEntityByName("hegrenade_projectile");
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				//에너지볼이 닿는 순간 공격하기 위한 훅
				SDKHook(entity, SDKHook_OnTakeDamage, EnergyBallDamageHook);
				SDKHook(entity, SDKHook_StartTouch, EnergyBallTouchHook);
				SDKHook(entity, SDKHook_Touch, EnergyBallTouchHook2);
				SetEntPropFloat(entity, Prop_Send, "m_flElasticity", 9999.0);
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				SetEntProp(entity, Prop_Send, "m_CollisionGroup", COLLISION_GROUP_NPC);
				energyballtouchcount[entity] = 0;
				
				setTakeDamage(entity, DAMAGE_NO);
				DispatchSpawn(entity);
				
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				SetEntityRenderMode(entity, RENDER_GLOW);
				SetEntityModel(entity, "models/effects/combineball.mdl");//콤바인볼
				new Float:vecmax[3] = {8.0, 8.0, 8.0};
				new Float:vecmin[3] = {-8.0, -8.0, -8.0};
				SetEntPropVector(entity, Prop_Send, "m_vecMins", vecmin);
				SetEntPropVector(entity, Prop_Send, "m_vecMaxs", vecmax);
				SetEntProp(entity, Prop_Send, "m_fEffects", GetEntProp(entity, Prop_Send, "m_fEffects") | EF_NOSHADOW);
				SetEntityMoveType(entity, MOVETYPE_FLY);//중력에 구애받지 않게 한다!
				TeleportEntity(entity, resultposition, clienteyeangle, anglevector);
				//소리
				playingenergyballsound[entity] = true;
				playsound(client, SOUNDTYPEENERGYBALLFIRE, clienteyeposition);
				playsound(entity, SOUNDTYPEENERGYBALLLOOP, clienteyeposition);
				CreateTimer(GetConVarFloat(cvar_energyball_life_time), energyballtimer, EntIndexToEntRef(entity));
				setTakeDamage(entity, DAMAGE_YES);
				
				CloakingDisable(client);
				
				makecustumviewpunch(client, selector_energyball);
				
			}else{
		
				chargingenergyball[client] = false;
				
			}
			
		}
		
	}else{
		
		chargingenergyball[client] = false;
		
	}
	
}

public Action:EnergyBallDamageHook(entity, &attacker, &inflictor, &Float:damage, &damagetype){
	
	return Plugin_Handled;
	
}

//에너지볼에 닿는 것에 데미지를 준다
public Action:EnergyBallTouchHook(entity, other){
	
	//이펙트와 소리를 만든다
	decl Float:entityposition[3], Float:entityspeed[3], Float:entityangle[3];
	GetEntPropVector(entity, Prop_Send, "m_vecOrigin", entityposition);
	GetEntPropVector(entity, Prop_Send, "m_vecVelocity", entityspeed);
	GetEntPropVector(entity, Prop_Send, "m_angRotation", entityangle);
	
	TE_SetupEnergySplash(entityposition, entityangle, true); 
	TE_SendToAll();
	
	new client = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
	
	if(other != 0){
		
		//발사한 사람의 몸에 닿더라도 터져서는 안된다
		if(other == client){
			
			return Plugin_Continue;
			
		}else{
		
			//닿아서 터져야 하는 것들의 목록 중에 단 한개도 일치하지 않는 경우
			if(!IsEntityCollidable(other, true, true, true)){
				
				return Plugin_Continue;
				
			}
			
		}
		
		//공격 소리를 낸다
		playsound(0, SOUNDTYPEENERGYBALLDISINTEGRATE, entityposition);
		//공격
		makeDamage(isClientConnectedIngame(client) ? client : 0, other, GetConVarInt(cvar_energyball_damage), DMG_DISSOLVE, 0.0, entityposition, ENERGYBALL_WEAPONNAME);
		
	}else{
		
		//월드에 닿을 경우 튕기는 소리를 낸다
		playsound(0, SOUNDTYPEENERGYBALLBOUNCE, entityposition);
		
	}
	
	energyballtouchcount[entity]++;
		
	if(energyballtouchcount[entity] >= GetConVarInt(cvar_energyball_touch_limit) && GetConVarInt(cvar_energyball_touch_limit) > 0){
		
		energyballtimer(INVALID_HANDLE, EntIndexToEntRef(entity));
		
	}else{
	
		if(GetVectorLength(entityspeed) <= 1.0){
			
			entityspeed[0] = GetRandomFloat();
			entityspeed[1] = GetRandomFloat();
			entityspeed[2] = GetRandomFloat();
			
		}
		
		NormalizeVector(entityspeed, entityspeed);
		ScaleVector(entityspeed, GetConVarFloat(cvar_energyball_projectile_speed));
		decl Float:angle[3];
		GetVectorAngles(entityspeed, angle);
		TeleportEntity(entity, NULL_VECTOR, angle, entityspeed);
		
	}
	
	return Plugin_Continue;
	
}

public Action:EnergyBallTouchHook2(entity, other){
	
	//코어의 이동 보정
	decl Float:entityposition[3], Float:entityspeed[3], Float:entityangle[3];
	GetEntPropVector(entity, Prop_Send, "m_vecOrigin", entityposition);
	GetEntPropVector(entity, Prop_Send, "m_vecVelocity", entityspeed);
	GetEntPropVector(entity, Prop_Send, "m_angRotation", entityangle);
	
	//이동속도가 일정 이하일 때의 보정
	if(GetVectorLength(entityspeed) <= 1.0){
		
		entityspeed[0] = GetRandomFloat();
		entityspeed[1] = GetRandomFloat();
		entityspeed[2] = GetRandomFloat();
		
	}
	
	NormalizeVector(entityspeed, entityspeed);
	ScaleVector(entityspeed, GetConVarFloat(cvar_energyball_projectile_speed));
	decl Float:angle[3];
	GetVectorAngles(entityspeed, angle);
	TeleportEntity(entity, NULL_VECTOR, angle, entityspeed);
	
	return Plugin_Continue;
	
}

public Action:energyballtimer(Handle:timer, any:entref){
	
	new entity = EntRefToEntIndex(entref);
	
	if(entity != -1){
		
		decl Float:entityposition[3];
		GetEntPropVector(entity, Prop_Send, "m_vecOrigin", entityposition);
		//엔티티 제거
		AcceptEntityInput(entity, "Kill");
		//폭발음을 일으킨다
		playsound(0, SOUNDTYPEENERGYBALLEXPLOSION, entityposition);
		new fullcolor[4] = {255, 255, 255, 255};
		TE_SetupBeamRingPoint(entityposition, 1.0, 300.0, plasmabeam, plasmahalo, 0, 10, 1.0, 20.0, 1.5, fullcolor, 1600, FBEAM_SINENOISE);
		TE_SendToAll();
		new Float:dirangle[3] = {-90.0, 0.0, 0.0};
		new Float:dir[3];
		GetAngleVectors(dirangle, dir, NULL_VECTOR, NULL_VECTOR);
		TE_SetupSparks(entityposition, dir, 200, 200);
		TE_SendToAll();
		
	}
	
}

stock empattack(client){
	
	//유탄을 발사한다
	
	new usingweapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
	
	if(usingweapon != -1){
			
		//탄환이 충분하고, 재장전이 끝났고, 무기의 다음 공격시간이 유효하고, 플레이어의 다음 공격시간이 유효한가 확인,
		//이것들을 하나라도 빠트리면 버그가 생겼다
		new ammo = GetEntProp(usingweapon, Prop_Data, "m_iClip1");
		
		if(ammo >= gunfunctionammo(client, selector_emp)
			&& !GetEntProp(usingweapon, Prop_Data, "m_bInReload")
			&& GetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack") <= GetGameTime()
			&& GetEntPropFloat(client, Prop_Data, "m_flNextAttack") <= GetGameTime()){
			
			if(useleftgunfunction(client, selector_emp)){
				
				//탄환이 충분하므로 탄환을 줄이고 발사를 시작한다
				SetEntProp(usingweapon, Prop_Data, "m_iClip1", ammo - gunfunctionammo(client, selector_emp));
				//다음 공격 시간을 늧춘다
				SetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack", FloatAdd(GetGameTime(), getgunfunctioncooltime(selector_emp)));
				
				decl Float:clienteyeangle[3], Float:anglevector[3], Float:clienteyeposition[3], Float:resultposition[3], entity;
				GetClientEyeAngles(client, clienteyeangle);
				GetClientEyePosition(client, clienteyeposition);
				GetAngleVectors(clienteyeangle, anglevector, NULL_VECTOR, NULL_VECTOR);
				NormalizeVector(anglevector, anglevector);
				//ScaleVector(anglevector, 10.0);
				AddVectors(clienteyeposition, anglevector, resultposition);
				NormalizeVector(anglevector, anglevector);
				ScaleVector(anglevector, GetConVarFloat(cvar_emp_projectile_speed));
				
				//이제 중요한 것 하나, 플레이어의 이동속도를 유탄의 속도에 더해야한다.
				//현실성은 중요한것
				decl Float:playerspeed[3];
				GetEntPropVector(client, Prop_Data, "m_vecVelocity", playerspeed);
				AddVectors(anglevector, playerspeed, anglevector);
				
				entity = CreateEntityByName("hegrenade_projectile");
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				SetEntityGravity(entity, 0.000001);
				
				setTakeDamage(entity, DAMAGE_NO);
				
				DispatchSpawn(entity);
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				SetEntityModel(entity, "models/Items/ar2_grenade.mdl");//유탄
				SetEntityRenderColor(entity, 255, 0, 0, 255);
				TeleportEntity(entity, resultposition, clienteyeangle, anglevector);
				//소리
				playsound(client, SOUNDTYPEGRENADE_LAUNCHER1, clienteyeposition);
				//유탄이 닿는 순간 터지게 하기 위한 훅
				SDKHook(entity, SDKHook_StartTouch, EMPTouchHook);
				//유탄이 공격당하는 순간 터지게 하기 위한 훅
				SDKHook(entity, SDKHook_OnTakeDamage, EMPDamageHook);
				
				setTakeDamage(entity, DAMAGE_YES);
				
				CloakingDisable(client);
				
				makecustumviewpunch(client, selector_emp);
				
			}
			
		}
		
	}
	
}

public Action:EMPTouchHook(entity, other){
	
	if(other != 0){
		
		//발사한 사람의 몸에 닿더라도 터져서는 안된다
		if(other == GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity")){
			
			return Plugin_Continue;
			
		}else{
		
			//닿아서 터져야 하는 것들의 목록 중에 단 한개도 일치하지 않는 경우
			if(!IsEntityCollidable(other, true, true, true)){
				
				return Plugin_Continue;
				
			}
			
		}
			
	}
	
	EMPActive(entity);
	
	return Plugin_Continue;
	
}

public Action:EMPDamageHook(entity, &attacker, &inflictor, &Float:damage, &damagetype){
	
	if(GetEntProp(entity, Prop_Data, "m_takedamage") == DAMAGE_YES){
	
		EMPActive(entity);
		
	}
	
	return Plugin_Continue;
	
}

stock EMPActive(entity){
	
	//유탄이 닿는 순간 터지게 하기 위한 훅
	SDKUnhook(entity, SDKHook_StartTouch, EMPTouchHook);
	//유탄이 공격당하는 순간 터지게 하기 위한 훅
	SDKUnhook(entity, SDKHook_OnTakeDamage, EMPDamageHook);
	
	if(GetEntProp(entity, Prop_Data, "m_takedamage") == DAMAGE_YES){
	
		setTakeDamage(entity, DAMAGE_NO);//더이상 데미지를 안 입게 한다
		decl Float:entityposition[3];
		GetEntPropVector(entity, Prop_Send, "m_vecOrigin", entityposition);
		new client = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
		entityposition[2] = entityposition[2] + 10.0;//폭발을 약간 위쪽으로, 데미지를 제대로 주기 위한 수단
		//폭발을 일으킨다
		makeExplosion(isClientConnectedIngame(client) ? client : 0, entity, entityposition, EMP_WEAPONNAME, GetConVarInt(cvar_emp_damage), GetConVarInt(cvar_emp_dmg_radius), _, SF_ENVEXPLOSION_NOFIREBALL | SF_ENVEXPLOSION_NOSMOKE | SF_ENVEXPLOSION_NODECAL | SF_ENVEXPLOSION_NOSPARKS | SF_ENVEXPLOSION_NOSOUND);
		//폭발음을 일으킨다
		playsound(0, SOUNDTYPEEXPLODE, entityposition);
		//유탄 엔티티 제거
		AcceptEntityInput(entity, "Kill");
		
	}
	
}

//마인어택
stock mineattack(client){
	
	//지뢰를 깐다
	
	new usingweapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
	
	if(usingweapon != -1){
			
		//탄환이 충분하고, 재장전이 끝났고, 무기의 다음 공격시간이 유효하고, 플레이어의 다음 공격시간이 유효한가 확인,
		//이것들을 하나라도 빠트리면 버그가 생겼다
		new ammo = GetEntProp(usingweapon, Prop_Data, "m_iClip1");
		
		if(ammo >= gunfunctionammo(client, selector_mine)
			&& !GetEntProp(usingweapon, Prop_Data, "m_bInReload")
			&& GetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack") <= GetGameTime()
			&& GetEntPropFloat(client, Prop_Data, "m_flNextAttack") <= GetGameTime()){
				
			if(useleftgunfunction(client, selector_mine)){
				
				//트레이스레이를 써서 지뢰를 깔 위치를 구한다
				decl Float:cleyepos[3], Float:cleyeangle[3];
						
				GetClientEyePosition(client, cleyepos);
				GetClientEyeAngles(client, cleyeangle);
				
				new Handle:traceresulthandle = INVALID_HANDLE;
				
				decl Float:traceresultposition[3], Float:mineresultposition[3], Float:mineresultnormalvector[3], Float:minevectorangle[3];
				
				traceresulthandle = TR_TraceRayFilterEx(cleyepos, cleyeangle, MASK_SOLID, RayType_Infinite, tracerayfilternoplayer, client);
				
				if(TR_DidHit(traceresulthandle)){
					
					//인질에게 마인을 깔면 안된다.ㅡ,.ㅡ
					decl String:classname[64];
					
					GetEdictClassname(TR_GetEntityIndex(traceresulthandle), classname, 64);
					
					if(!StrEqual(classname, "hostage_entity", false)){
						
						TR_GetEndPosition(traceresultposition, traceresulthandle);
						TR_GetPlaneNormal(traceresulthandle, mineresultnormalvector);
						
						NormalizeVector(mineresultnormalvector, mineresultnormalvector);
						ScaleVector(mineresultnormalvector, 4.0);
						AddVectors(traceresultposition, mineresultnormalvector, mineresultposition);
						GetVectorAngles(mineresultnormalvector, minevectorangle);
						//여기서 얻어낸 것은 마인의 위치와 각도이다
						
						if(80 >= GetVectorDistance(cleyepos, traceresultposition)){
							
							//탄환이 충분하므로 탄환을 줄이고 발사를 시작한다
							SetEntProp(usingweapon, Prop_Data, "m_iClip1", ammo - gunfunctionammo(client, selector_mine));
							//다음 공격 시간을 늧춘다
							SetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack", FloatAdd(GetGameTime(), getgunfunctioncooltime(selector_mine)));
							
							decl String:input[128];
							
							//지뢰엔티티를 만든다
							new physicalmineentity = CreateEntityByName("prop_physics_override");
							DispatchKeyValue(physicalmineentity, "model", "models/items/battery.mdl");
							DispatchKeyValueVector(physicalmineentity, "origin", mineresultposition);
							DispatchKeyValueVector(physicalmineentity, "angles", minevectorangle);
							
							if(TR_GetEntityIndex(traceresulthandle) != 0){
							
								minegroundentity[physicalmineentity] = EntIndexToEntRef(TR_GetEntityIndex(traceresulthandle));
								
							}else{
								
								minegroundentity[physicalmineentity] = 0;
								
							}
							
							decl String:targetname[128];
							
							//빔의 시작 위치를 구하기 위한 계산(시작위치 = 레이저가 닿은 벽면, 끝위치 = 마인이 심어진 위치)
							new Handle:traceresulthandle2 = INVALID_HANDLE;
							decl Float:beamstartpos[3];
							traceresulthandle2 = TR_TraceRayFilterEx(traceresultposition, minevectorangle, MASK_SOLID, RayType_Infinite, tracerayfilternoplayer, client);			
							if(TR_DidHit(traceresulthandle2)){
						
								TR_GetEndPosition(beamstartpos, traceresulthandle2);
								
							}
							CloseHandle(traceresulthandle2);
							
							//엔브빔엔티티 생성
							new envbeamentity = CreateEntityByName("env_beam");
							
							mineentity[envbeamentity] = EntIndexToEntRef(physicalmineentity);
							
							//엔브빔 엔티티 타겟네임 설정
							Format(targetname, 128, "%f%f", GetGameTime(), GetRandomFloat());
							DispatchKeyValue(envbeamentity, "targetname", targetname);
							DispatchKeyValue(envbeamentity, "LightningStart", targetname);
							//시작위치 위치설정
							//NormalizeVector(resultnormal, resultnormal);
							//ScaleVector(resultnormal, 3.0);
							//AddVectors(resultposition, resultnormal, resultposition);
							DispatchKeyValueVector(envbeamentity, "origin", beamstartpos);
							
							//각종 빔엔티티 설정
							//렌더링색설정
							DispatchKeyValue(envbeamentity, "renderamt", "150");
							//렌더링효과설정
							DispatchKeyValue(envbeamentity, "renderfx", "15");
							new team = GetClientTeam(client);
							
							if(team == CS_TEAM_CT){
								
								DispatchKeyValue(envbeamentity, "rendercolor", "0 0 255");
								
							}else if(team == CS_TEAM_T){
								
								DispatchKeyValue(envbeamentity, "rendercolor", "255 64 64");
								
							}
							
							//굵기설정
							DispatchKeyValue(envbeamentity, "BoltWidth", "1.0");
							//모델설정
							DispatchKeyValue(envbeamentity, "texture", "materials/sprites/laser.vmt");
							//지속시간설정
							DispatchKeyValue(envbeamentity, "life", "0.0");
							DispatchKeyValue(envbeamentity, "StrikeTime", "0");
							DispatchKeyValue(envbeamentity, "TextureScroll", "35");
							DispatchKeyValue(envbeamentity, "framerate", "10");
							DispatchKeyValue(envbeamentity, "framestart", "10");
							DispatchKeyValue(envbeamentity, "TouchType", "4");
							
							//엔브빔에 아웃펏을 넣는다
							Format(input, 128, "%s,FireUser2,,0,-1", targetname);
							DispatchKeyValue(envbeamentity, "OnTouchedByEntity", input);
							
							//엔브빔 엔티티의 끝 위치 설정 이전에, 마인을 스폰해야한다
							setTakeDamage(physicalmineentity, DAMAGE_NO);
							DispatchSpawn(physicalmineentity);
							setTakeDamage(physicalmineentity, DAMAGE_NO);//마인은 현재 작동하지 않는다
							AcceptEntityInput(physicalmineentity, "DisableMotion");
							//SetEntProp(physicalmineentity, Prop_Data, "m_CollisionGroup", COLLISION_GROUP_NONE);
							//SetEntProp(physicalmineentity, Prop_Data, "m_MoveCollide", MOVECOLLIDE_DEFAULT);
							//SetEntProp(physicalmineentity, Prop_Data, "m_nSolidType", SOLID_VPHYSICS);
							SetEntPropEnt(physicalmineentity, Prop_Send, "m_hOwnerEntity", client);
							SetEntPropEnt(physicalmineentity, Prop_Send, "m_hEffectEntity", envbeamentity);
							
							//이제 또한번의 트레이스를 써서, 엔브빔의 끝위치를 구한다
							new Handle:traceresulthandle3 = INVALID_HANDLE;
							decl Float:beamendpos[3];
							
							decl Float:pointvector[3], Float:pointangle[3];
							MakeVectorFromPoints(beamstartpos, traceresultposition, pointvector);
							GetVectorAngles(pointvector, pointangle);
							
							traceresulthandle3 = TR_TraceRayFilterEx(beamstartpos, pointangle, MASK_SOLID, RayType_Infinite, tracerayfilternoplayer, client);			
							if(TR_DidHit(traceresulthandle3)){
						
								TR_GetEndPosition(beamendpos, traceresulthandle3);
								
							}
							CloseHandle(traceresulthandle3);
							
							SetEntPropVector(envbeamentity, Prop_Data, "m_vecEndPos", beamendpos);
							
							DispatchSpawn(envbeamentity);
							SetEntProp(physicalmineentity, Prop_Data, "m_iHealth", 0);
							
							//이 작업은 엔브빔 엔티티의 스폰 이후에 해야한다
							SetEntityModel(envbeamentity, "materials/sprites/laser.vmt");
							
							AcceptEntityInput(envbeamentity, "TurnOff");
							
							CreateTimer(4.0, StartMine, EntIndexToEntRef(envbeamentity), TIMER_FLAG_NO_MAPCHANGE);
							
							SDKHook(physicalmineentity, SDKHook_OnTakeDamage, MineDamageHook);
							SDKHook(physicalmineentity, SDKHook_EndTouch, MineEndTouchHook);
							HookSingleEntityOutput(envbeamentity, "OnUser2", minebeamoutputhook);
							
							setTakeDamage(physicalmineentity, DAMAGE_YES);//이 시점부터 마인이 작동한다
							
							//효과음 내기
							playsound(client, SOUNDTYPEMINEPUT, cleyepos);
						
						}
							
					}
					
				}
				
				CloseHandle(traceresulthandle);
				
			}
			
		}
		
	}
	
}

public Action:StartMine(Handle:timer, any:envbeamentity){

	if(EntRefToEntIndex(envbeamentity) != -1){
		
		AcceptEntityInput(envbeamentity, "TurnOn");
		decl Float:entityposition[3];
		GetEntPropVector(EntRefToEntIndex(envbeamentity), Prop_Send, "m_vecOrigin", entityposition);
		playsound(0, SOUNDTYPEMINEACT, entityposition);
		
	}
	
}

public minebeamoutputhook(const String:output[], envbeamentity, activator, Float:delay){
	
	new physicalmineentity = EntRefToEntIndex(mineentity[envbeamentity]);
	
	new bool:keepsensing = true;
	
	if(physicalmineentity != -1){
		
		new client = GetEntPropEnt(physicalmineentity, Prop_Send, "m_hOwnerEntity");
		
		if(isClientConnectedIngame(client)){
			
			if(isClientConnectedIngameAlive(activator)){
				
				if(GetClientTeam(client) != GetClientTeam(activator)){
					
					MineActive(physicalmineentity);
					keepsensing = false;
					
				}
				
			}
			
		}
		
	}else{
		
		keepsensing = false;
		
	}
	
	if(keepsensing){
		
		decl String:input[128];
		AcceptEntityInput(envbeamentity, "TurnOff");
		Format(input, 128, "OnUser1 !self:TurnOn::0.0:1");
		SetVariantString(input);
		AcceptEntityInput(envbeamentity, "AddOutput");
		AcceptEntityInput(envbeamentity, "FireUser1");
		
	}
	
}

public MineEndTouchHook(entity, other){
	
	if(EntRefToEntIndex(minegroundentity[entity]) == other){
		
		MineActive(entity);
		
	}
	
}

public Action:MineDamageHook(entity, &attacker, &inflictor, &Float:damage, &damagetype){
	
	//지금까지의 데미지의 총합을 계산한다
	SetEntProp(entity, Prop_Data, "m_iHealth", GetEntProp(entity, Prop_Data, "m_iHealth") + RoundToNearest(damage));
	//데미지를 얼마 이상 먹은 경우!
	if(GetEntProp(entity, Prop_Data, "m_iHealth") >= GetConVarInt(cvar_mine_damage_to_break)){
	
		MineActive(entity);
		
	}
	
	return Plugin_Handled;
	
}

stock MineActive(physicalmineentity){
	
	SDKUnhook(physicalmineentity, SDKHook_OnTakeDamage, MineDamageHook);
	SDKUnhook(physicalmineentity, SDKHook_EndTouch, MineEndTouchHook);
	
	if(GetEntProp(physicalmineentity, Prop_Data, "m_takedamage") == DAMAGE_YES){
		
		setTakeDamage(physicalmineentity, DAMAGE_NO);//더이상 데미지를 안 입게 한다
		new client = GetEntPropEnt(physicalmineentity, Prop_Send, "m_hOwnerEntity");
		new beamentity = GetEntPropEnt(physicalmineentity, Prop_Send, "m_hEffectEntity");//빔엔티티를 구한다
		decl Float:entityposition[3], Float:entityangle[3], Float:entityanglevector[3];
		GetEntPropVector(beamentity, Prop_Data, "m_vecEndPos", entityposition);
		GetEntPropVector(physicalmineentity, Prop_Send, "m_angRotation", entityangle);
		GetAngleVectors(entityangle, entityanglevector, NULL_VECTOR, NULL_VECTOR);
		NormalizeVector(entityanglevector, entityanglevector);
		ScaleVector(entityanglevector, 4.0);
		AddVectors(entityposition, entityanglevector, entityposition);
		AcceptEntityInput(beamentity, "kill");//빔엔티티 삭제
		
		//물리엔진 크래시를 막기 위한 묘책?
		//new Float:teleport[3] = {999999.9, 999999.9, 999999.0};
		//AcceptEntityInput(physicalmineentity, "EnableMotion");
		//TeleportEntity(physicalmineentity, teleport, NULL_VECTOR, NULL_VECTOR);
		//과연 이 묘책이 먹힐것인가?
		//이 해결법은 물리엔진이 깨지는 이유가 마인엔티티가 땅과 겹쳐진 채로 사라져서 라고 가정한다
		
		//폭발을 일으킨다
		makeExplosion(isClientConnectedIngame(client) ? client : 0, physicalmineentity, entityposition, MINE_WEAPONNAME, GetConVarInt(cvar_mine_damage), GetConVarInt(cvar_mine_dmg_radius));
		//폭발음을 일으킨다
		playsound(0, SOUNDTYPEEXPLODE, entityposition);
		AcceptEntityInput(physicalmineentity, "Kill");
		
	}
	
}

//센서어택
stock sensorattack(client){
	
	//센서를 발사한다
	
	new usingweapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
	
	if(usingweapon != -1){
			
		//탄환이 충분하고, 재장전이 끝났고, 무기의 다음 공격시간이 유효하고, 플레이어의 다음 공격시간이 유효한가 확인,
		//이것들을 하나라도 빠트리면 버그가 생겼다
		new ammo = GetEntProp(usingweapon, Prop_Data, "m_iClip1");
		
		if(ammo >= gunfunctionammo(client, selector_sensor)
			&& !GetEntProp(usingweapon, Prop_Data, "m_bInReload")
			&& GetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack") <= GetGameTime()
			&& GetEntPropFloat(client, Prop_Data, "m_flNextAttack") <= GetGameTime()){
			
			if(useleftgunfunction(client, selector_sensor)){
				
				//탄환이 충분하므로 탄환을 줄이고 발사를 시작한다
				SetEntProp(usingweapon, Prop_Data, "m_iClip1", ammo - gunfunctionammo(client, selector_sensor));
				//다음 공격 시간을 늧춘다
				SetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack", FloatAdd(GetGameTime(), getgunfunctioncooltime(selector_sensor)));
				
				decl Float:clienteyeangle[3], Float:anglevector[3], Float:clienteyeposition[3], Float:resultposition[3], entity;
				GetClientEyeAngles(client, clienteyeangle);
				GetClientEyePosition(client, clienteyeposition);
				GetAngleVectors(clienteyeangle, anglevector, NULL_VECTOR, NULL_VECTOR);
				NormalizeVector(anglevector, anglevector);
				//ScaleVector(anglevector, 10.0);
				AddVectors(clienteyeposition, anglevector, resultposition);
				NormalizeVector(anglevector, anglevector);
				ScaleVector(anglevector, GetConVarFloat(cvar_sensor_projectile_speed));
				
				//이제 중요한 것 하나, 플레이어의 이동속도를 발사된 센서의 속도에 더해야한다.
				//현실성은 중요한것
				decl Float:playerspeed[3];
				GetEntPropVector(client, Prop_Data, "m_vecVelocity", playerspeed);
				AddVectors(anglevector, playerspeed, anglevector);
				
				entity = CreateEntityByName("hegrenade_projectile");
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				setTakeDamage(entity, DAMAGE_NO);
				DispatchSpawn(entity);
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				SetEntityModel(entity, "models/items/combine_rifle_ammo01.mdl");//센서의 모델은 ar2의 코어아이템 모델
				//SetEntityGravity(entity, 1.0);//중력 조절, 센서는 한번 날아가기 시작한 힘으로 아주 멀리까지도 날아가므로
				SetEntityMoveType(entity, MOVETYPE_FLY);//중력에 구애받지 않게 한다! 센서는 특수체
				//소리
				playsound(client, SOUNDTYPESENSORFIRE, clienteyeposition);
				//센서가 닿는 순간 센서를 발동시켜야 한다
				SDKHook(entity, SDKHook_StartTouch, SensorTouchHook);
				//센서가 공격당하는 순간 터지게 하기 위한 훅
				SDKHook(entity, SDKHook_OnTakeDamage, SensorDamageHook);
				TeleportEntity(entity, resultposition, clienteyeangle, anglevector);
				setTakeDamage(entity, DAMAGE_YES);
				
				makecustumviewpunch(client, selector_sensor);
				
			}
			
		}
		
	}
	
}

public Action:SensorTouchHook(entity, other){
	
	if(other != 0){
		
		//발사한 사람의 몸에 닿더라도 터져서는 안된다
		if(other == GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity")){
			
			return Plugin_Continue;
			
		}else{
		
			//닿아서 작동을 시작해야 하는 것들의 목록 중에 단 한개도 일치하지 않는 경우
			if(!IsEntityCollidable(other, false, false, false)){
				
				return Plugin_Continue;
				
			}
			
		}
			
	}
	
	SensorActive(entity);
	
	return Plugin_Continue;
	
}

public Action:SensorDamageHook(entity, &attacker, &inflictor, &Float:damage, &damagetype){
	
	AcceptEntityInput(entity, "kill");
	
	return Plugin_Continue;
	
}

stock SensorActive(sensorentity){
	
	//센서가 닿는 순간 센서를 발동시켜야 한다
	SDKUnhook(sensorentity, SDKHook_StartTouch, SensorTouchHook);
	//센서가 공격당하는 순간 터지게 하기 위한 훅
	SDKUnhook(sensorentity, SDKHook_OnTakeDamage, SensorDamageHook);
	
	if(GetEntProp(sensorentity, Prop_Data, "m_takedamage") == DAMAGE_YES){
		
		setTakeDamage(sensorentity, DAMAGE_NO);//더이상 데미지를 안 입게 한다
		new client = GetEntPropEnt(sensorentity, Prop_Send, "m_hOwnerEntity");
		decl Float:entityposition[3], Float:entityangle[3];
		GetEntPropVector(sensorentity, Prop_Data, "m_vecOrigin", entityposition);
		GetEntPropVector(sensorentity, Prop_Send, "m_angRotation", entityangle);
		AcceptEntityInput(sensorentity, "kill");//센서엔티티 삭제(이것은 hegrenade_projectile이므로, 허공에 제대로 멈출 수가 없다)
		
		entityposition[2] = entityposition[2] + 1.0;//땅에 박힌 센서가 작동하지 않는 것에 대한 보정
		
		//새로운 센서 엔티티를 만든다!
		new physicalsensorentity = CreateEntityByName("prop_physics_override");
		DispatchKeyValue(physicalsensorentity, "model", "models/items/combine_rifle_ammo01.mdl");
		DispatchKeyValueVector(physicalsensorentity, "origin", entityposition);
		DispatchKeyValueVector(physicalsensorentity, "angles", entityangle);
		setTakeDamage(physicalsensorentity, DAMAGE_NO);
		DispatchSpawn(physicalsensorentity);
		AcceptEntityInput(physicalsensorentity, "DisableMotion");
		//SetEntProp(physicalsensorentity, Prop_Data, "m_CollisionGroup", COLLISION_GROUP_NONE);
		//SetEntProp(physicalsensorentity, Prop_Data, "m_MoveCollide", MOVECOLLIDE_DEFAULT);
		//SetEntProp(physicalsensorentity, Prop_Data, "m_nSolidType", SOLID_VPHYSICS);
		SetEntPropEnt(physicalsensorentity, Prop_Send, "m_hOwnerEntity", client);
		
		//센서 탐지를 위한 함수를 위한 정보
		new Handle:datapack = CreateDataPack();
		//이 센서의 엔티티 레퍼런스를 담아둔다
		WritePackCell(datapack, EntIndexToEntRef(physicalsensorentity));
		WritePackFloat(datapack, GetEngineTime() + GetConVarFloat(cvar_sensor_life_time));
		//바로 실행되는 타이머
		CreateTimer(GetConVarFloat(cvar_sensor_think_delay), SensorThink, datapack, TIMER_REPEAT | TIMER_FLAG_NO_MAPCHANGE | TIMER_DATA_HNDL_CLOSE);
		
		setTakeDamage(physicalsensorentity, DAMAGE_YES);//이 시점부터 센서를 파괴하는 것이 가능하다
		
		//센서의 작동 시작음을 일으킨다
		playingsensorsound[physicalsensorentity] = true;
		playsound(0, SOUNDTYPESENSORATTACH, entityposition);
		playentitysound(physicalsensorentity, SOUNDSENSORACTIVE, entityposition);
		
	}
	
}

//센서의 감지코드
public Action:SensorThink(Handle:Timer, Handle:data){
	
	//리셋팩
	decl sensorentity, client, Float:lifetime;
	ResetPack(data);
	sensorentity = ReadPackCell(data);
	sensorentity = EntRefToEntIndex(sensorentity);
	lifetime = ReadPackFloat(data);
	
	//센서엔티티가 존재한다
	if(sensorentity != -1){
	
		client = GetEntPropEnt(sensorentity, Prop_Send, "m_hOwnerEntity");
		
		//클라이언트가 아직 접속해있고 살아있는가?
		if(isClientConnectedIngameAlive(client)){
			
			//수명이 다하지 않았는가
			if(lifetime >= GetEngineTime()){
			
				//살아있으므로 감지해서 레이져 이펙트를 만들어보낸다
				
				for(new target = 1; target <= MaxClients; target++){
					
					//타겟이 클라이언트가 아니고 타겟이 살아있을 경우
					if(target != client && isClientConnectedIngameAlive(target)){
						
						//트레이스를 써서 감지한다
						decl Float:sensorposition[3], Float:targetposition[3], Float:vectordirection[3], Float:angledirection[3];
						GetEntPropVector(sensorentity, Prop_Data, "m_vecOrigin", sensorposition);
						GetClientEyePosition(target, targetposition);
						targetposition[2] = targetposition[2] - 15.0;//몸통의 가운데 부분을 구한다
						
						MakeVectorFromPoints(sensorposition, targetposition, vectordirection);
						GetVectorAngles(vectordirection, angledirection);
								
						new Handle:traceresulthandle = INVALID_HANDLE;
				
						traceresulthandle = TR_TraceRayFilterEx(sensorposition, angledirection, MASK_SOLID, RayType_Infinite, tracerayfilterdefault, sensorentity);
				
						if(TR_DidHit(traceresulthandle)){
					
							if(TR_GetEntityIndex(traceresulthandle) == target){
								
								detectedbysensor[client][target] = true;
								
								if(GetClientTeam(client) != GetClientTeam(target)){
									
									detectedonminimap[target] = true;
									
								}
										
							}
									
						}
								
						CloseHandle(traceresulthandle);
					
					}
					
				}
				
				return Plugin_Continue;
				
			}else{
				
				//수명이 다했으므로 장식물 상태가 된다
				decl Float:entityposition[3];
				GetEntPropVector(sensorentity, Prop_Data, "m_vecOrigin", entityposition);
				AcceptEntityInput(sensorentity, "kill");
				playsound(0, SOUNDTYPESENSORDEACTIVE, entityposition);
				return Plugin_Stop;
				
			}
				
		}else{
		
			//클라이언트가 살아있지 않으므로 더이상 어떤 감지도 하지 않는, 장식물 상태가 된다
			decl Float:entityposition[3];
			GetEntPropVector(sensorentity, Prop_Data, "m_vecOrigin", entityposition);
			AcceptEntityInput(sensorentity, "kill");
			playsound(0, SOUNDTYPESENSORDEACTIVE, entityposition);
			return Plugin_Stop;
			
		}
		
	}else{
		
		return Plugin_Stop;
		
	}
	
}

stock specialgrenadeattack(client){
	
	//유탄을 발사한다
	
	new usingweapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
	
	if(usingweapon != -1){
			
		//탄환이 충분하고, 재장전이 끝났고, 무기의 다음 공격시간이 유효하고, 플레이어의 다음 공격시간이 유효한가 확인,
		//이것들을 하나라도 빠트리면 버그가 생겼다
		new ammo = GetEntProp(usingweapon, Prop_Data, "m_iClip1");
		
		if(ammo >= gunfunctionammo(client, selector_specialgrenade)
			&& !GetEntProp(usingweapon, Prop_Data, "m_bInReload")
			&& GetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack") <= GetGameTime()
			&& GetEntPropFloat(client, Prop_Data, "m_flNextAttack") <= GetGameTime()){
			
			if(useleftgunfunction(client, selector_specialgrenade)){
				
				//탄환이 충분하므로 탄환을 줄이고 발사를 시작한다
				SetEntProp(usingweapon, Prop_Data, "m_iClip1", ammo - gunfunctionammo(client, selector_specialgrenade));
				//다음 공격 시간을 늧춘다
				SetEntPropFloat(usingweapon, Prop_Data, "m_flNextPrimaryAttack", FloatAdd(GetGameTime(), getgunfunctioncooltime(selector_specialgrenade)));
				
				decl Float:clienteyeangle[3], Float:anglevector[3], Float:clienteyeposition[3], Float:resultposition[3], entity;
				GetClientEyeAngles(client, clienteyeangle);
				GetClientEyePosition(client, clienteyeposition);
				GetAngleVectors(clienteyeangle, anglevector, NULL_VECTOR, NULL_VECTOR);
				NormalizeVector(anglevector, anglevector);
				//ScaleVector(anglevector, 10.0);
				AddVectors(clienteyeposition, anglevector, resultposition);
				NormalizeVector(anglevector, anglevector);
				ScaleVector(anglevector, GetConVarFloat(cvar_specialgrenade_projectile_speed));
				
				//이제 중요한 것 하나, 플레이어의 이동속도를 유탄의 속도에 더해야한다.
				//현실성은 중요한것
				decl Float:playerspeed[3];
				GetEntPropVector(client, Prop_Data, "m_vecVelocity", playerspeed);
				AddVectors(anglevector, playerspeed, anglevector);
				
				entity = CreateEntityByName("hegrenade_projectile");
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				//SetEntityGravity(entity, 0.5);
				setTakeDamage(entity, DAMAGE_NO);
				DispatchSpawn(entity);
				SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
				SetEntityModel(entity, "models/weapons/w_grenade.mdl");//하프2수류탄
				SetEntPropFloat(entity, Prop_Send, "m_flElasticity", 0.5);
				//소리
				playsound(client, SOUNDTYPEGRENADE_LAUNCHER1, clienteyeposition);
				//유탄이 닿는 순간 터지게 하기 위한 훅
				SDKHook(entity, SDKHook_StartTouch, specialgrenadeTouchHook);
				//유탄이 공격당하는 순간 터지게 하기 위한 훅
				SDKHook(entity, SDKHook_OnTakeDamage, specialgrenadeDamageHook);
				SDKHook(entity, SDKHook_ShouldCollide, specialgrenadeCollideHook);
				
				//타겟네임 설정
				decl String:targetname[64], String:steamid[32];
				GetClientAuthString(client, steamid, 32);
				Format(targetname, 64, "%sstickynade", steamid);
				DispatchKeyValue(entity, "targetname", targetname);
				
				HookSingleEntityOutput(entity, "OnUser4", specialgrenadeoutputhook);
				HookSingleEntityOutput(entity, "OnUser3", specialgrenadeoutputhook);
				
				if(GetConVarFloat(cvar_specialgrenade_life_time) > 0.0){
				
					CreateTimer(GetConVarFloat(cvar_specialgrenade_life_time), specialgrenadetimer, EntIndexToEntRef(entity));
				
				}
					
				TeleportEntity(entity, resultposition, clienteyeangle, anglevector);
				
				setTakeDamage(entity, DAMAGE_YES);
				
				CloakingDisable(client);
				
				makecustumviewpunch(client, selector_grenade);
				
			}
			
		}
		
	}
	
}

detonateSpecialGrenade(client, bool:nodamage){

	decl String:targetname[64], String:steamid[32], String:input[128];
	GetClientAuthString(client, steamid, 32);
	Format(targetname, 64, "%sstickynade", steamid);
	
	if(nodamage){
	
		Format(input, 128, "%s,FireUser3,,0,1", targetname);
		DispatchKeyValue(client, "OnUser3", input);
		AcceptEntityInput(client, "FireUser3");
		
	}else{
	
		Format(input, 128, "%s,FireUser4,,0,1", targetname);
		DispatchKeyValue(client, "OnUser4", input);
		AcceptEntityInput(client, "FireUser4");
	
	}

}

public specialgrenadeoutputhook(const String:output[], entity, activator, Float:delay){
	
	if(StrEqual(output, "OnUser3", false)){
	
		specialgrenadeActive(entity, true);
	
	}else if(StrEqual(output, "OnUser4", false)){
	
		specialgrenadeActive(entity, false);
	
	}
	
}

public bool:specialgrenadeCollideHook(entity, collisiongroup, contentsmask, bool:result){
	
	if(SolidType_t:GetEntProp(entity, Prop_Data, "m_nSolidType") == SOLID_NONE){
		
		result = false;
		return false;
			
	}
	
	return true;
	
}

public Action:specialgrenadetimer(Handle:timer, any:entref){
	
	new entity = EntRefToEntIndex(entref);
	
	if(entity != -1){
		
		specialgrenadeActive(entity, false);
		
	}
	
}

public Action:specialgrenadeTouchHook(entity, other){
	
	if(other != 0){
		
		//발사한 사람의 몸에 닿더라도 터져서는 안된다
		if(other == GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity")){
			
			return Plugin_Continue;
			
		}else{
		
			//닿아서 터져야 하는 것들의 목록 중에 단 한개도 일치하지 않는 경우
			if(!IsEntityCollidable(other, true, true, false)){
				
				return Plugin_Continue;
				
			}else{
				
				//이것은 플레이어 엔티티인가?
				if(isClientConnectedIngameAlive(other)){
					
					//같은 팀인 경우
					if(GetClientTeam(other) == GetClientTeam(GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity"))){
						
						if(GetConVarBool(cvar_specialgrenade_stick_to_player) && GetConVarBool(cvar_specialgrenade_stick_to_teammate)){
							
							SetVariantString("!activator");
							AcceptEntityInput(entity, "SetParent", other);
							SetEntityMoveType(entity, MOVETYPE_VPHYSICS);
							SetEntPropEnt(entity, Prop_Send, "m_hEffectEntity", other);
							SetEntProp(entity, Prop_Data, "m_nSolidType", SOLID_NONE);
							SDKUnhook(entity, SDKHook_StartTouch, specialgrenadeTouchHook);
							
						}
						
					}else{
						
						if(GetConVarBool(cvar_specialgrenade_detonateontouchenemy)){
						
							specialgrenadeActive(entity, false);
						
						}else if(GetConVarBool(cvar_specialgrenade_stick_to_player)){
							
							SetVariantString("!activator");
							AcceptEntityInput(entity, "SetParent", other);
							SetEntityMoveType(entity, MOVETYPE_VPHYSICS);
							SetEntPropEnt(entity, Prop_Send, "m_hEffectEntity", other);
							SetEntProp(entity, Prop_Data, "m_nSolidType", SOLID_NONE);
							SDKUnhook(entity, SDKHook_StartTouch, specialgrenadeTouchHook);
							
						}
						
					}
					
				}else if(GetConVarBool(cvar_specialgrenade_detonateontouchprop)){
						
					specialgrenadeActive(entity, false);
				
				}else if(GetConVarBool(cvar_specialgrenade_stick_to_prop)){
					
					//프롭이고 스티키 그레네이드가 프롭에 붙게 되어있을 경우
					SetVariantString("!activator");
					AcceptEntityInput(entity, "SetParent", other);
					SetEntityMoveType(entity, MOVETYPE_VPHYSICS);
					SetEntPropEnt(entity, Prop_Send, "m_hEffectEntity", other);
					SetEntProp(entity, Prop_Data, "m_nSolidType", SOLID_NONE);
					SDKUnhook(entity, SDKHook_StartTouch, specialgrenadeTouchHook);
					
				}
				
			}
			
		}
			
	}else if(GetConVarBool(cvar_specialgrenade_stick_to_world)){
		
		SetEntProp(entity, Prop_Data, "m_nSolidType", SOLID_NONE);
		SetEntityMoveType(entity, MOVETYPE_NONE);
		SetEntPropEnt(entity, Prop_Send, "m_hEffectEntity", other);
		SDKUnhook(entity, SDKHook_StartTouch, specialgrenadeTouchHook);
		
	}
	
	return Plugin_Continue;
	
}

public Action:specialgrenadeDamageHook(entity, &attacker, &inflictor, &Float:damage, &damagetype){
	
	if(GetEntProp(entity, Prop_Data, "m_takedamage") == DAMAGE_YES){
	
		specialgrenadeActive(entity, false);
		
	}
	
	return Plugin_Continue;
	
}

stock specialgrenadeActive(entity, bool:nodamage){
	
	//유탄이 닿는 순간 터지게 하기 위한 훅
	SDKUnhook(entity, SDKHook_StartTouch, specialgrenadeTouchHook);
	//유탄이 공격당하는 순간 터지게 하기 위한 훅
	SDKUnhook(entity, SDKHook_OnTakeDamage, specialgrenadeDamageHook);
	
	if(GetEntProp(entity, Prop_Data, "m_takedamage") == DAMAGE_YES){
	
		setTakeDamage(entity, DAMAGE_NO);//더이상 데미지를 안 입게 한다
		decl Float:entityposition[3];
		
		new effectentity = GetEntPropEnt(entity, Prop_Send, "m_hEffectEntity");
		
		if(effectentity != -1 && effectentity != 0){
			
			GetEntPropVector(GetEntPropEnt(entity, Prop_Send, "m_hEffectEntity"), Prop_Send, "m_vecOrigin", entityposition);
			
		}else{
			
			GetEntPropVector(entity, Prop_Send, "m_vecOrigin", entityposition);	
			
		}
		
		//유탄 엔티티 제거
		AcceptEntityInput(entity, "Kill");
		new client = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
		entityposition[2] = entityposition[2] + 10.0;//폭발을 약간 위쪽으로, 데미지를 제대로 주기 위한 수단
		//폭발을 일으킨다
		makeExplosion(isClientConnectedIngame(client) ? client : 0, entity, entityposition, specialgrenade_WEAPONNAME, (nodamage ? 0 : GetConVarInt(cvar_specialgrenade_damage)), (nodamage ? 0 : GetConVarInt(cvar_specialgrenade_dmg_radius)));
		//폭발음을 일으킨다
		playsound(0, SOUNDTYPEEXPLODE, entityposition);
		//유탄 엔티티 제거
		AcceptEntityInput(entity, "Kill");
		
	}
	
}

specialskillmenu(client){
	
	new Handle:menuhandle = CreateMenu(specialskillmenuhandler);
	
	decl String:txt[64];
	Format(txt, 64, "%T", "specialskillmenutitle", client);
	SetMenuTitle(menuhandle, txt);
	
	Format(txt, 64, "%T", "specialskillmenudisable", client);
	AddMenuItem(menuhandle, txt, txt);
	
	new clientteam = GetClientTeam(client);
	
	Format(txt, 64, "%T", "specialskillmenunuke", client);
	if(kills[client] >= killsforspecialskill[skilltype_nuke] && teamcanusespecialskill[skilltype_nuke][clientteam]){
			
		AddMenuItem(menuhandle, txt, txt);
			
	}else{
			
		AddMenuItem(menuhandle, txt, txt, ITEMDRAW_DISABLED);
			
	}
	
	SetMenuExitButton(menuhandle, true);
	
	DisplayMenu(menuhandle, client, MENU_TIME_FOREVER);
	
}

public specialskillmenuhandler(Handle:menu, MenuAction:action, client, select){
	
	if(action == MenuAction_Select){
		
		if(isClientConnectedIngameAlive(client)){
		
			if(teamcanusespecialskill[skilltype_none][GetClientTeam(client)]){
			
				if(select == 0){
				
					PrintToChat(client, "\x04%T", "specialskill-disable", client);
					specialskillmode[client] = skilltype_none;
				
				}else if(select == 1){
					
					if(kills[client] >= killsforspecialskill[skilltype_nuke] && teamcanusespecialskill[skilltype_nuke][GetClientTeam(client)]){
					
						PrintToChat(client, "\x04%T", "specialskill-nuke", client);
						specialskillmode[client] = skilltype_nuke;
						
					}else{
						
						PrintToChat(client, "\x04%T", "specialskillmenunotsupported", client);
						
					}
					
				}
				
			}
			
		}
		
	}else if(action == MenuAction_Cancel){
			
		if(select == MenuCancel_Exit){
			
			
			
		}
		
	}else if(action == MenuAction_End){
			
		CloseHandle(menu);
		
	}else if(action == MenuAction_DisplayItem){
		
		decl String:display[64];
		GetMenuItem(menu, select, "", 0, _, display, sizeof(display));
		decl String:buffer[255];
		Format(buffer, sizeof(buffer), "%T", display, client);
		//return RedrawMenuItem(buffer);
		
	}else if(action == MenuAction_Display){
		
		new Handle:panel = Handle:select;
		decl String:buffer[255];
		Format(buffer, sizeof(buffer), "%T", "specialskillmenutitle", client);
		SetPanelTitle(panel, buffer);
	
	}
	
}

usenukeskill(client){
	
	decl String:clientname[32];
	GetClientName(client, clientname, 32);
	
	PrintToChatAll("\x04%T", "specialskillnukelaunched", client, clientname);
	
	//폭격 코드
	
	//이곳에 폭격 시작 소리 코드가 온다
	for(new i = 1; i <= MaxClients; i++){
			
		if(isClientConnectedIngame(i))playsoundfromclient(i, SOUNDNUKEDETECT);
		
	}
	
	//클라이언트가 조준하는 곳의 위치를 구한다
	//조준한 위치의 노말벡터만큼 떨어진 곳을 구해서, 바닥쪽으로 트레이스를 해서, 바닥의 위치를 구한다.
	//바닥의 위치를 구한 뒤에는, 바닥의 위치로부터 하늘쪽으로 트레이스를 해서, 하늘에 충분한 공간이 있는지
	//구한다. 충분한 공간이 있으면 미사일을 투하하고, 충분한 공간이 없다면 그냥 시간이 지나면 땅 위치에서 핵을 터트린다
	
	//방향 : 90.0 x y 가 아래를 보는것, -90.0 x y 는 위를 보는것
	
	decl Float:cleyepos[3], Float:cleyeangle[3];
			
	GetClientEyePosition(client, cleyepos);
	GetClientEyeAngles(client, cleyeangle);
	
	new Handle:traceresulthandle = INVALID_HANDLE;
	
	//바라보는 곳의 위치를 구해서 노말벡터 만큼 떨어진 곳의 위치를 구한다
	decl Float:traceresultposition[3], Float:resultnormal[3];
	traceresulthandle = TR_TraceRayFilterEx(cleyepos, cleyeangle, MASK_SOLID, RayType_Infinite, tracerayfilteronlyworld, 0);
						
	if(TR_DidHit(traceresulthandle)){
		
		TR_GetEndPosition(traceresultposition, traceresulthandle);
		TR_GetPlaneNormal(traceresulthandle, resultnormal);
		
		//노말 벡터만큼 떨어진 곳의 위치를 구한다
		AddVectors(traceresultposition, resultnormal, traceresultposition);
		
		//이제 노말 벡터만큼 떨어진 곳에서 하늘의 위치를 구한다
		new Float:upangle[3] = {-90.0, 0.0, 0.0};
		
		new Handle:traceresulthandle2 = INVALID_HANDLE;
		decl Float:skyposition[3];
		traceresulthandle2 = TR_TraceRayFilterEx(traceresultposition, upangle, MASK_SOLID, RayType_Infinite, tracerayfilteronlyworld, 0);
		
		if(TR_DidHit(traceresulthandle2)){
		
			TR_GetEndPosition(skyposition, traceresulthandle2);
			
			//하늘의 위치를 구했으므로 땅의 위치를 구한다
			new Float:downangle[3] = {90.0, 0.0, 0.0};
		
			new Handle:traceresulthandle3 = INVALID_HANDLE;
			decl Float:groundposition[3];
			traceresulthandle3 = TR_TraceRayFilterEx(skyposition, downangle, MASK_SOLID, RayType_Infinite, tracerayfilteronlyworld, 0);
			
			if(TR_DidHit(traceresulthandle3)){
				
				TR_GetEndPosition(groundposition, traceresulthandle3);
				
				//소리를 낸다!
				//발사음
				playsoundfromallclient(SOUNDNUKEDETECT);
				//발사음 몇초 뒤에 들릴 경보음
				CreateTimer(TIMETOSTARTNUKEWARNINGSOUND, startnukewarningsound, _, TIMER_FLAG_NO_MAPCHANGE);
				
				//이제 하늘과 땅의 위치를 모두 구했으므로 처리를 시작한다
				if(GetVectorDistance(groundposition, skyposition) >= MINDISTTOSHOWNUKE){
					
					//핵미사일을 보여줄 공간여유가 된다!
					//핵미사일을 투하하도록 하는 타이머를 만든다
					skyposition[2] = skyposition[2] - NUKESTARTDISTANCEFROMSKY;
					
					new Handle:datapack = CreateDataPack();
					WritePackCell(datapack, GetClientUserId(client));
					WritePackFloat(datapack, skyposition[0]);
					WritePackFloat(datapack, skyposition[1]);
					WritePackFloat(datapack, skyposition[2]);
					
					CreateTimer(TIMETOSHOWNUKE, firenuke, datapack, TIMER_FLAG_NO_MAPCHANGE & TIMER_DATA_HNDL_CLOSE);
					
				}else{
					
					//핵미사일을 보여줄 공간여유가 안된다!
					//그냥 땅에서 터트리는 타이머를 만든다
					new Handle:datapack = CreateDataPack();
					WritePackCell(datapack, GetClientUserId(client));
					WritePackFloat(datapack, groundposition[0]);
					WritePackFloat(datapack, groundposition[1]);
					WritePackFloat(datapack, groundposition[2]);
					
					CreateTimer(TIMETOSHOWNUKE, justboomnuke, datapack, TIMER_FLAG_NO_MAPCHANGE & TIMER_DATA_HNDL_CLOSE);
					
				}
				
			}
			
			if(traceresulthandle3 != INVALID_HANDLE){
		
				CloseHandle(traceresulthandle3);
				
			}
			
		}
		
		if(traceresulthandle2 != INVALID_HANDLE){
		
			CloseHandle(traceresulthandle2);
			
		}
		
	}
	
	if(traceresulthandle != INVALID_HANDLE){
		
		CloseHandle(traceresulthandle);
		
	}
	
}

public Action:startnukewarningsound(Handle:timer, Handle:hndl){
	
	playsoundfromallclient(SOUNDNUKEFIRE);
	
}

public Action:firenuke(Handle:timer, Handle:datapack){
	
	ResetPack(datapack);
	new client = GetClientOfUserId(ReadPackCell(datapack));
	
	decl Float:position[3];
	position[0] = ReadPackFloat(datapack);
	position[1] = ReadPackFloat(datapack);
	position[2] = ReadPackFloat(datapack);
	
	new entity = CreateEntityByName("hegrenade_projectile");
	SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
	setTakeDamage(entity, DAMAGE_NO);
	DispatchSpawn(entity);
	SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
	SetEntityModel(entity, NUKEMODEL);//콤바인 헤드크랩 미사일
	SetEntityMoveType(entity, MOVETYPE_FLY);//중력에 구애받지 않게 한다!
	
	decl Float:angle[3], Float:anglevector[3];
	angle[0] = 90.0;//이것은 모델이 날아가는 방향을 아래로 할 뿐이다!
	angle[1] = 0.0;
	angle[2] = 0.0;
	
	GetAngleVectors(angle, anglevector, NULL_VECTOR, NULL_VECTOR);
	NormalizeVector(anglevector, anglevector);
	ScaleVector(anglevector, NUKE_SPEED);
	
	angle[0] = 90.0;//모델에 따라 수정해야됨
	angle[1] = 0.0;
	angle[2] = 0.0;
	
	TeleportEntity(entity, position, angle, anglevector);
	
	playentitysound(entity, SOUNDROCKET1, position);
	playingrocketsound[entity] = true;
	
	setTakeDamage(entity, DAMAGE_YES);
	
	//미사일이 닿는 순간 터지게 하기 위한 훅
	SDKHook(entity, SDKHook_StartTouch, NukeTouchHook);
	//미사일이 공격당하면 터지게 하기 위한 훅
	SDKHook(entity, SDKHook_OnTakeDamage, NukeDamageHook);
	
	return Plugin_Handled;
	
}

public Action:NukeTouchHook(entity, other){
	
	if(other != 0){
		
		//발사한 사람의 몸에 닿더라도 터져서는 안된다
		if(other == GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity")){
			
			return Plugin_Continue;
			
		}else{
		
			//닿아서 작동을 시작해야 하는 것들의 목록 중에 단 한개도 일치하지 않는 경우
			if(!IsEntityCollidable(other, true, true, true)){
				
				return Plugin_Continue;
				
			}
			
		}
			
	}
	
	NukeActive(entity);
	
	return Plugin_Continue;
	
}

public Action:NukeDamageHook(entity, &attacker, &inflictor, &Float:damage, &damagetype){
	
	//지금까지의 데미지의 총합을 계산한다
	SetEntProp(entity, Prop_Data, "m_iHealth", GetEntProp(entity, Prop_Data, "m_iHealth") + RoundToNearest(damage));
	//데미지를 얼마 이상 먹은 경우!
	if(GetEntProp(entity, Prop_Data, "m_iHealth") >= NUKE_DAMAGE_TO_BREAK){
	
		NukeActive(entity);
		
	}
	
	return Plugin_Handled;
	
}

stock NukeActive(entity){
	
	//미사일이 닿는 순간 터지게 하기 위한 훅
	SDKUnhook(entity, SDKHook_StartTouch, RocketTouchHook);
	//미사일이 공격당하는 순간 터지게 하기 위한 훅
	SDKUnhook(entity, SDKHook_OnTakeDamage, RocketDamageHook);
	
	if(GetEntProp(entity, Prop_Data, "m_takedamage") == DAMAGE_YES){
	
		setTakeDamage(entity, DAMAGE_NO);//더이상 데미지를 안 입게 한다
		decl Float:entityposition[3];
		GetEntPropVector(entity, Prop_Send, "m_vecOrigin", entityposition);
		new client = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
		AcceptEntityInput(entity, "Kill");
		entityposition[2] = entityposition[2] + 10.0;
		//폭발을 일으킨다
		makeExplosion(isClientConnectedIngame(client) ? client : 0, entity, entityposition, NUKE_WEAPONNAME, NUKEDAMAGE);
		nukekill(isClientConnectedIngame(client) ? client : 0, entityposition);
		nukeeffect(entityposition);
		
	}
	
}

public Action:justboomnuke(Handle:timer, Handle:datapack){
	
	ResetPack(datapack);
	new client = GetClientOfUserId(ReadPackCell(datapack));
	
	decl Float:position[3];
	position[0] = ReadPackFloat(datapack);
	position[1] = ReadPackFloat(datapack);
	position[2] = ReadPackFloat(datapack);
	
	//폭발을 일으킨다
	makeExplosion(isClientConnectedIngame(client) ? client : 0, -1, position, NUKE_WEAPONNAME, NUKEDAMAGE);
	nukekill(isClientConnectedIngame(client) ? client : 0, position);
	nukeeffect(position);
	
	
}

nukeeffect(const Float:position[3]){
	
	playsoundfromallclient(SOUNDNUKEEXPLODE);
	sendFadeMsg(0, 1000, 1000, FFADE_IN, 255, 255, 255, 130);
	sendShakeMsg(0, all:SHAKE_START, 80.0, 80.0, 10.0);
	
	new particle = CreateEntityByName("info_particle_system");
	    
	new String:output[128];
	if(particle != -1){
		
		DispatchKeyValueVector(particle, "Origin", position);
		
		DispatchKeyValue(particle, "effect_name", "bomb_explosion_huge");
            
		DispatchSpawn(particle);

		ActivateEntity(particle);
		AcceptEntityInput(particle, "start");
		
		Format(output, 512, "OnUser1 !self:stop:justkill:20.0:1");
		SetVariantString(output);
		AcceptEntityInput(particle, "AddOutput");
		
		Format(output, 512, "OnUser1 !self:kill:justkill:60.0:1");
		SetVariantString(output);
		AcceptEntityInput(particle, "AddOutput");
		
		AcceptEntityInput(particle, "FireUser1");
		
	}

}

nukekill(attacker, const Float:position[3]){
	
	decl Float:targetposition[3];
	
	for(new i = 1; i <= MaxClients; i++){
			
		if(isClientConnectedIngameAlive(i)){
			
			GetClientAbsOrigin(i, targetposition);
			
			if(GetVectorDistance(targetposition, position) <= DISTTONUKEKILL){
				
				makeExplosion(isClientConnectedIngame(attacker) ? attacker : 0, -1, targetposition, NUKE_WEAPONNAME, NUKEDAMAGE, 100);
				
			}
			
		}
		
	}
	
}

public suitmodemenu(client){
	
	new Handle:menuhandle = CreateMenu(suitmodemenuhandler);
	
	new bool:menuisselectable = false;
	
	decl String:txt[64], String:typestring[32];
	
	Format(txt, 64, "%T", "suitmodeselectmenutitle", client);
	SetMenuTitle(menuhandle, txt);
	
	new clientteam = GetClientTeam(client);
	
	
	if(teamcanusesuitfunction(clientteam, suitmode_charge)){
		
		menuisselectable = true;
		Format(txt, 64, "%T", "suitmodeselectmenurecharge", client);
		IntToString(suitmode_charge, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
			
	}
	
	if(teamcanusesuitfunction(clientteam, suitmode_speed)){
		
		menuisselectable = true;
		Format(txt, 64, "%T", "suitmodeselectmenuspeed", client);
		IntToString(suitmode_speed, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
			
	}
	
	if(teamcanusesuitfunction(clientteam, suitmode_strength)){
		
		menuisselectable = true;
		Format(txt, 64, "%T", "suitmodeselectmenustrength", client);		
		IntToString(suitmode_strength, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
			
	}
	
	if(teamcanusesuitfunction(clientteam, suitmode_cloak)){
		
		menuisselectable = true;
		Format(txt, 64, "%T", "suitmodeselectmenucloak", client);
		IntToString(suitmode_cloak, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
			
	}
	
	if(teamcanusesuitfunction(clientteam, suitmode_shield)){
		
		menuisselectable = true;
		Format(txt, 64, "%T", "suitmodeselectmenushield", client);
		IntToString(suitmode_shield, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
			
	}
	
	if(teamcanusesuitfunction(clientteam, suitmode_sensor)){
		
		menuisselectable = true;
		Format(txt, 64, "%T", "suitmodeselectmenusensor", client);		
		IntToString(suitmode_sensor, typestring, 32);
		AddMenuItem(menuhandle, typestring, txt);
			
	}
	
	SetMenuExitButton(menuhandle, true);
	
	if(menuisselectable){
	
		DisplayMenu(menuhandle, client, MENU_TIME_FOREVER);
		
	}else{
		
		CloseHandle(menuhandle);
		PrintToChat(client, "\x04%T", "suitmodeselectmenunotavailable", client);
		
	}
	
}

public suitmodemenuhandler(Handle:menu, MenuAction:action, client, select){
	
	if(action == MenuAction_Select){
		
		if(isClientConnectedIngameAlive(client)){
		
			new String:infobuffer[64], String:displaybuffer[64], style;
			GetMenuItem(menu, select, infobuffer, 64, style, displaybuffer, 64);
			
			new suitmodeselector:selectedtype = suitmodeselector:StringToInt(infobuffer); 
			
			setclientsuitfucntion(client, selectedtype, true);
			
		}
		
	}else if(action == MenuAction_Cancel){
			
		if(select == MenuCancel_Exit){
			
			
			
		}
		
	}else if(action == MenuAction_End){
			
		CloseHandle(menu);
		
	}else if(action == MenuAction_DisplayItem){
		
		decl String:display[64];
		GetMenuItem(menu, select, "", 0, _, display, sizeof(display));
		decl String:buffer[255];
		Format(buffer, sizeof(buffer), "%T", display, client);
		//return RedrawMenuItem(buffer);
		
	}else if(action == MenuAction_Display){
		
		new Handle:panel = Handle:select;
		decl String:buffer[255];
		SetGlobalTransTarget(client);
		Format(buffer, sizeof(buffer), "%T", "suitmodeselectmenutitle", client);
		SetPanelTitle(panel, buffer);
	
	}
	
}

public OnEntityDestroyed(entity){
	
	if(0 <= entity && entity < 2048){
	
		if(playingrocketsound[entity]){
			
			//소리 중지
			stopentitysound(entity, SOUNDROCKET1);
			playingrocketsound[entity] = false;
			
		}
		if(playingenergyballsound[entity]){
			
			//소리 중지
			stopentitysound(entity, SOUNDENERGYBALLLOOP);
			playingenergyballsound[entity] = false;
			
		}
		if(playingsensorsound[entity]){
			
			stopentitysound(entity, SOUNDSENSORACTIVE);
			playingsensorsound[entity] = false;
			
		}
		
	}
	
}

stock CloakingDisable(client){
	
	if(suitmode[client] == suitmode_cloak){
			
		PrintToChat(client, "\x04%T", "cloakattack", client);
		
		setclientsuitfucntion(client, suitmode_charge);
		
	}

}

stock makecustumviewpunch(client, gunselector:type){
	
	new Float:angle[3] = {0.0, 0.0, 0.0};
	
	if(type == selector_grenade){
		
		angle[0] = -12.0;
		angle[1] = GetRandomFloat(-4.0, 4.0);
		
	}else if(type == selector_rocket){
		
		angle[0] = -6.0;
		angle[1] = GetRandomFloat(-2.0, 2.0);
		
	}else if(type == selector_sensor){
		
		angle[0] = -3.0;
		angle[1] = GetRandomFloat(-2.0, 2.0);
		
	}else if(type == selector_energyball){
		
		angle[0] = -15.0;
		angle[1] = GetRandomFloat(-7.0, 7.0);
		
	}else if(type == selector_emp){
		
		angle[0] = -3.0;
		angle[1] = GetRandomFloat(-2.0, 2.0);
		
	}
	
	makeviewpunch(client, angle);
	
}

stock bool:GetGunSelectorName(client, gunselector:selector, String:buffer[], buffersize){
	
	if(gunselector == selector_grenade){
		
		Format(buffer, buffersize, "%T", "gunselectormenugrenade", client);
		
	}else if(gunselector == selector_rocket){
		
		Format(buffer, buffersize, "%T", "gunselectormenurocket", client);
		
	}else if(gunselector == selector_mine){
		
		Format(buffer, buffersize, "%T", "gunselectormenumine", client);
		
	}else if(gunselector == selector_sensor){
		
		Format(buffer, buffersize, "%T", "gunselectormenusensor", client);
		
	}else if(gunselector == selector_heal){
		
		Format(buffer, buffersize, "%T", "gunselectormenuheal", client);
		
	}else if(gunselector == selector_energyball){
		
		Format(buffer, buffersize, "%T", "gunselectormenuenerngyball", client);
		
	}else if(gunselector == selector_emp){
		
		Format(buffer, buffersize, "%T", "gunselectormenuemp", client);
		
	}else if(gunselector == selector_specialgrenade){
		
		Format(buffer, buffersize, "%T", "gunselectormenuspecialgrenade", client);
		
	}else{
		
		return false;
		
	}
	
	return true;
	
}